/**
 * 
 */
package cs307.first;

/**
 * @author -
 *
 */
public class Director_1 implements Director {

	/* (non-Javadoc)
	 * @see cs307.first.Director#makeBuilder(cs307.first.Director.Descriptor)
	 */
	@Override
	public Builder makeBuilder(Descriptor dd) {
		if (!(dd instanceof BitVector.Descriptor)) {
			throw new ImplementationError("Bad descriptor");
		}
		
		BitVector.Descriptor d = (BitVector.Descriptor) dd;
		
		int size = d.getUpperBound() - d.getLowerBound();
		if (size <= 0) {
			//The upper and lower bounds are out of range
			throw new ImplementationError("Bounds out of range");
		}
		
		//Pick which builder to use
		
		if (d.optimizeSpeed() && size <= 128) {
			return new BuilderSmall_1(d);
		} else {
			return new BuilderBig_1(d);
		}
		
		//return null;
	}

}
