/**
 * 
 */
package cs307.first;

import java.util.NoSuchElementException;

import cs307.first.BitVector.Iterator;

/**
 * @author -
 *
 */
public class Iterator_1 implements Iterator {
	
	private int position;
	private int upper;
	private boolean strict;
	private BitVector vector;
	
	

	/**
	 * @param vector
	 * @param position
	 * @param upper
	 * @param strict
	 */
	public Iterator_1(BitVector vector, int position, int upper,
			boolean strict) {
		super();
		this.vector = vector;
		this.position = position;
		this.upper = upper;
		this.strict = strict;
	}

	/* (non-Javadoc)
	 * @see cs307.first.BitVector.Iterator#getNext()
	 */
	@Override
	public boolean getNext() {
		if (!hasNext() && strict) {
			throw new BitVector.NoSuchElementError("Out of range.");
		}
		boolean bit = vector.test(position);
		position++;
		
		return bit;
	}

	/* (non-Javadoc)
	 * @see cs307.first.BitVector.Iterator#hasNext()
	 */
	@Override
	public boolean hasNext() {
		
		return position <= upper;
	}

	/* (non-Javadoc)
	 * @see cs307.first.BitVector.Iterator#position()
	 */
	@Override
	public int position() {
		
		return position;
	}

	/* (non-Javadoc)
	 * @see cs307.first.BitVector.Iterator#skipToSet()
	 */
	@Override
	public int skipToSet() {
		int p;
		
		do {
			p = position;
		} while (!getNext());
		
		return p;
	}

	/* (non-Javadoc)
	 * @see cs307.first.BitVector.Iterator#skipToUnset()
	 */
	@Override
	public int skipToUnset() {
		
		int p;
		
		do {
			p = position;
		} while (getNext());
		
		return p;
	}

}
