
package cs307.first;

public class MyBitVector_13 implements BitVector{
	boolean _bits[];
	int _size;
	int _ref;
	boolean _checked;
	BitVector.Builder _builder;
	public MyBitVector_13(int size, int ref, boolean checked, BitVector.Builder b){
		_bits = new boolean[size];
		_size = size;
		_ref = ref;
		_checked = checked;
		_builder = b;
	}
	public boolean test(int index){
		if(_checked){
			checkBounds(index);
		}
		else{
			return _bits[index];
		}
		return false;
	}
	public boolean set(int index){
		if(_checked){
			checkBounds(index);
		}
		_bits[index] = true;
		return true;
	}
	public boolean unset(int index){
		if(_checked){
			checkBounds(index);
		}
		_bits[index] = false;
		return true;
	}
	public boolean negate(int index){
		if(_checked){
			checkBounds(index);
		}
		return false;
	}
	public void and(BitVector bs){
		for(int i = 0; i < _size; i++){
			MyBitVector_13 bb = (MyBitVector_13)bs;
			_bits[i] = bb._bits[i] & _bits[i];
		}
	}
	public void or(BitVector bs){
		for(int i = 0; i < _size; i++){
			MyBitVector_13 bb = (MyBitVector_13)bs;
			_bits[i] = bb._bits[i] | _bits[i];
		}
	}
	public void xor(BitVector bs){
		for(int i = 0; i < _size; i++){
			MyBitVector_13 bb = (MyBitVector_13)bs;
			_bits[i] = bb._bits[i] ^ _bits[i];
		}
	}
	public BitVector copy(){
		try{
			return (MyBitVector_13)this.clone();
		}
		catch(java.lang.CloneNotSupportedException e){
			return null;
		}
	}
	public Iterator iterator(){
		return new MyIterator(this);
	}
	public Builder builder(){
		return null;
	}
	public String toString(){
		String str = new String();
		if(_checked){
			str = "Full Check\n";
		}
		str += "Size=" + _size + "\n";
		for(int i = 0; i < _size; i++){
			str += _bits[i] + "\n";
		}
		return str;
	}
	public void checkBounds(int index){
		if(index - _ref > _size){
			throw new ImplementationError("Index out of bounds");
		}
	}

	public class MyIterator implements Iterator{
		MyBitVector_13 _bv;
		int _pos;
		int _size;
		public MyIterator(MyBitVector_13 bv){
			_bv = bv;
			_pos = 0;
			_size = bv._size;
		}
		public boolean hasNext(){
			if(_pos < _size)
				return true;
			else
				return false;
		}
		public boolean getNext(){
			return _bv._bits[_pos++];
		}
		public int position(){
			return _pos;
		}
		public int skipToSet(){
			for(int i = _pos; i < _size; i++){
				if(_bv._bits[i]){
					_pos = i;
					return _pos;
				}
			}
			return -1;
		}
		public int skipToUnset(){
			for(int i = _pos; i < _size; i++){
				if(!_bv._bits[i]){
					_pos = i;
					return _pos;
				}
			}
			return -1;
		
		
		}
	}
}
