package cs307.first;

import cs307.first.BitVector;

public class MySmallVector_13 implements BitVector {
	int[] _bits;
	BitVector.Builder _builder;
	int _size;
	int _ref;
	boolean _checked;
	
	/**
	 * @param size
	 * @param ref
	 * @param checked
	 * @param b
	 */
	public MySmallVector_13(int size, 
							int ref, 
							boolean checked,
							BitVector.Builder b){
		_size = size;
		_ref = ref;
		_checked = checked;
		_builder = b;
		_bits = new int[_size / 32 + 1];
	}

	public void and(cs307.first.BitVector bs) {
		for(int i = 0; i < _size; i++){
			_bits[i] = _bits[i] & ((MySmallVector_13)bs)._bits[i];
		}	
	}

	public Builder builder() {
		return this._builder;
	}

	public cs307.first.BitVector copy() {
		try{
			return (BitVector)this.clone();
		}
		catch(Exception e){
			return null;
		}
	}

	public Iterator iterator() {
		return new SmallVectorIterator();
	}


	public boolean negate(int index) {
		if(this.test(index))
			this.unset(index);
		else
			this.set(index);
		return true;
	}

	public void or(cs307.first.BitVector bs) {
		for(int i = 0; i < _size; i++){
			_bits[i] = _bits[i] | ((MySmallVector_13)bs)._bits[i];
		}

	}

	public boolean test(int index) {
		int i = index / 32;
		int offset = index % 32;
		int mask = 1 << offset;
		if((_bits[i] & mask) == mask){
			return true;
		}
		else{	
			return false;
		}
	}

	public boolean set(int index) {
		int i = index / 32;
		int offset = index % 32;
		int mask = 1 << offset;
		_bits[i] = _bits[i] | mask;
		return true;
	}

	public boolean unset(int index) {
		int i = index / 32;
		int offset = index % 32;
		int mask = 1 << offset;
		mask = ~mask;
		_bits[i] = _bits[i] & mask;
		
		return true;
	}

	public void xor(cs307.first.BitVector bs) {
		// TODO Auto-generated method stub
		for(int i = 0; i < _size; i++){
			_bits[i] = ((MySmallVector_13)bs)._bits[i] ^ _bits[i];
		}
	}
	public class SmallVectorIterator implements Iterator{
		int _position;
		int _mask;
		public boolean getNext() {
			_mask = _mask << 1;
			if(_mask == 0){
				_mask = 1;
				_position++;
			}
			return false;
		}

		public boolean hasNext() {
			if(32 * _position + _mask == _size)
				return false;
			else
				return true;
		}

		public int position() {
			return 32 * _position + _mask;
		}

		public int skipToSet() {
			while(this.hasNext())
				if(this.getNext())
					break;
			return 32 * _position + _mask;
		}

		public int skipToUnset() {
			while(this.hasNext())
				if(!this.getNext())
					break;
			return 32 * _position + _mask;
		}
	
	}
}
