package cs307.first;
import threeohseven.BitVector;
//import threeohseven.Director;
import threeohseven.ImplementationError;
public class BitVector_19 implements BitVector
{
	int max;
	boolean[] list;
	Builder b;

	BitVector_19(int n, Builder bb)
	{
		max = n;
		b = bb;
		list = new boolean[max+1];
		for (int x = 0; x <= max; x++)
			list[x] = false;
		
	}
	
	//returns the max
	public int max()
	{
		return max;
	}
	/**
     * Test the value at <code>index</code>.  The operation is only valid
     * if <code>index</code> is in the active range of the
     * <code>BitVector</code>.
     * @param index a value in the active range
     * @return value at <code>index</code> 
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
    public boolean test(int index)
	{
		if (index <= max) return list[index];
		throw new ImplementationError("Index out of range");
	}
    /**
     * Set the bit at <code>index</code>.  The operation is only valid if
     * <code>index</code> is in the active range of the
     * <code>BitVector</code>.
     * @param index a value in the active range
     * @return old value at <code>index</code>
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
    public boolean set(int index)
	{
		boolean old;
		if (index <= max)
		{
			old = list[index];
			list[index] = true;
			return old;
		}
		throw new ImplementationError("Index out of range");
	}
    /**
     * Unset the bit at <code>index</code>.  The operation is only valid if
     * <code>index</code> is in the active range of the
     * <code>BitVector</code>.
     * @param index a value in the active range
     * @return old value at <code>index</code>
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
    public boolean unset(int index)
	{
		boolean old;
		if (index <= max)
		{
			old = list[index];
			list[index] = false;
			return old;
		}
		throw new ImplementationError("Index out of range");
	}
    /**
     * Negate the bit at <code>index</code>.  The operation is only valid
     * if <code>index</code> is in the active range of the
     * <code>BitVector</code>.
     * @param index a value in the active range
     * @return old value at <code>index</code>
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
    public boolean negate(int index)
	{
		if (index <= max)
		{
			list[index] = !list[index];
			return !list[index];
		}
		throw new ImplementationError("Index out of range");
	}
    /**
     * Logical <code>and</code> of the two vectors. Receiver is updated in
     * place.  The operation is only valid if <code>index</code> is in the
     * active range of the <code>BitVector</code>.
     * @param bs the other <code>BitVector</code>.
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
    public void and(BitVector bs)
	{
		if (builder().compatible(bs.builder()))
			for (int x = 0; x <= max; x++)
			{
				if (bs.test(x) && list[x])
					bs.set(x);
				else bs.unset(x);
			}
		else throw new ImplementationError("Not compatible bitvectors");
	}
    /**
     * Logical <code>or</code> of the two vectors. Receiver is updated in
     * place.  The operation is only valid if the two
     * <code>BitVector</code> objects are compatible.
     * @param bs the other <code>BitVector</code>.
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
    public void or(BitVector bs)
	{
		if (builder().compatible(bs.builder()))
			for (int x = 0; x <= max; x++)
			{
				if (bs.test(x) || list[x])
					bs.set(x);
				else bs.unset(x);
			}
		else throw new ImplementationError("Not compatible bitvectors");
	}
    /**
     * Logical <code>xor</code> of the two vectors. Receiver is updated in
     * place.  The operation is only valid if the two
     * <code>BitVector</code> objects are compatible.
     * @param bs the other <code>BitVector</code>.
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
    public void xor(BitVector bs)
	{
		if (builder().compatible(bs.builder()))
			for (int x = 0; x <= max; x++)
			{
				if ((bs.test(x) && !list[x]) || (!bs.test(x) && list[x]))
					bs.set(x);
				else bs.unset(x);
			}
		else throw new ImplementationError("Not compatible bitvectors");
	}
  	/**
     * Returns a logically disjoint deep copy of the object.
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code>
     **/
    public BitVector copy()
	{
		BitVector_19 bs = new BitVector_19(max, b);
		for (int x = 0; x <= max; x++)
		{
			if (list[x]) bs.set(x);
			else bs.unset(x);
		}
		return bs;
	}
    /**
     * Returns an iterator over this <code>BitVector</code>.
     **/
    public Iterator iterator()
	{
		return new BVIterator();
	}
    /**
     * Returns the builder that created this <code>BitVector</code>.
     **/
    public Builder builder()
	{
		return b;
	}

    /**
     * Return a representation of this <code>BitVector</code> as a
     * string. The format is implementation specific.
     **/
	public String toString()
	{
		return "this bitvector has a max value of " + max;
	}

	private class BVIterator implements BitVector.Iterator
	{
		int cur;
		BVIterator()
		{
			cur = 0;
		}
		/**
	 * Are there more values in the active range?
	 * @return false if the end of the range has been reached.
	 **/
	public boolean hasNext()
	{
		cur++;
		if (cur <= max) return true;
		else return false;
	}

	/**
	 * Returns the value for the current cursor, and advances the
	 * cursor by one. When the cursor overflows the active range
	 * (i.e. <code>hasNext()</code> is false) arbitrary values may be
	 * returned. Implementations are not required to throw an exception.
  	 * @return the value of the next index in range.
  	 * @throws NoSuchElementError if hasNext() == false and vector is strict.
	 **/
	public boolean getNext()
	{
		cur++;
		if (cur <=max+1) return list[cur -1];
		else return false;
	}

	/**
	 * The value of the cursor. This value may be larger than the
	 * vector's upper bound. In which case <code>hasNext()</code> will
	 * return false.
	 * @return current position.
	 **/
	public int position()
	{
		return cur;
	}

	/**
	 * Skips to the next set bit such that <code>getNext()</code> will
	 * return true, if none is found the cursor is moved to the end of
	 * the vector and <code>hasNext()</code> will return false from
	 * thereon.
	 * @return position of the first set bit, if there is none an
	 * invalid value will be returned (ie a value larger than the upper
	 * bound of the array).
	 **/
	public int skipToSet()
	{
		cur++;
		for ( ; cur <= max; cur++)
		{
			if (list[cur]) break;
		}
		return cur;
	}

	/**
	 * Skips to the next unset bit such that <code>getNext()</code>
	 * will return false, if none is found the cursor is moved to the
	 * end of the vector and <code>hasNext()</code> will return false
	 * from thereon.
	 * @return position of the first unset bit, if there is none an
	 * invalid value will be returned (ie a value larger than the upper
	 * bound of the array).
	 **/
	public int skipToUnset()
	{
		cur++;
		for ( ; cur <= max; cur++)
		{
			if (!list[cur]) break;
		}
		return cur;
	}
	}
}