package test.first.u19;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import cs307.first.BitVector_19;
import cs307.first.Director_19;

import threeohseven.BitVector;
import threeohseven.BitVector.Iterator;

public class BitVector_19Test {
	
	BitVector_19 bv;
	BitVector_19 bv2;
	BitVector.Builder b;

	@Before
	public void setUp() throws Exception {
		 Director_19 d = new Director_19();
		final BitVector.Descriptor small = new BitVector.Descriptor(0, 31, false, true, true);
		final BitVector.Builder builder =  (BitVector.Builder) d.makeBuilder(small);
		b = builder;
		bv = (BitVector_19) builder.buildBitVector();
		bv2 = (BitVector_19) builder.buildBitVector();
		
	}

	@After
	public void tearDown() throws Exception {
		bv = null;
		bv2 = null;
		b = null;
	}



	@Test
	public void testTest() {
		assertEquals(".test()",bv.test(23), false);
	}

	@Test
	public void testSet() {
		assertEquals(".set() : Setting index 7 to true", bv.set(7), false);
		assertEquals(".set() : Making sure index 7 is true", bv.test(7), true);
		assertEquals(".set() : Setting index 7 to true (again)", bv.set(7), true);
	}

	@Test
	public void testUnset() {
		assertEquals(".set() : Setting index 12 to false", bv.unset(12), false);
		assertEquals(".set() : Making sure index 12 is false", bv.test(12), false);
		assertEquals(".set() : Setting index 12 to false (again)", bv.unset(12), false);
	}

	@Test
	public void testNegate() {
		assertEquals(".negate() : making 13 true", bv.negate(13),false);
		assertEquals(".negate() : 13 should be true", bv.test(13), true);
		assertEquals(".negate() : making 13 false", bv.negate(13), true);
	}

	@Test
	public void testAnd() {
		bv.unset(3);
		bv2.unset(3);
		bv.and(bv2);
		assertEquals(".and() : 1", bv2.test(3), false);
		bv.set(4);
		bv2.unset(4);
		bv.and(bv2);
		assertEquals(".and() : 2", bv2.test(4), false);
		bv.set(5);
		bv2.set(5);
		bv.and(bv2);
		assertEquals(".and() : 3", bv2.test(5), true);
		bv.unset(6);
		bv2.set(6);
		bv.and(bv2);
		assertEquals(".and() : 2", bv2.test(6), false);
	}

	@Test
	public void testOr() {
		bv.unset(3);
		bv2.unset(3);
		bv.or(bv2);
		assertEquals(".or() : 1", bv2.test(3), false);
		bv.set(4);
		bv2.unset(4);
		bv.or(bv2);
		assertEquals(".or() : 2", bv2.test(4), true);
		bv.set(5);
		bv2.set(5);
		bv.or(bv2);
		assertEquals(".or() : 3", bv2.test(5), true);
		bv.unset(6);
		bv2.set(6);
		bv.or(bv2);
		assertEquals(".or() : 4", bv2.test(6), true);
	}

	@Test
	public void testXor() {
		bv.unset(3);
		bv2.unset(3);
		bv.xor(bv2);
		assertEquals(".xor() : 1", bv2.test(3), false);
		bv.set(4);
		bv2.unset(4);
		bv.xor(bv2);
		assertEquals(".xor() : 2", bv2.test(4), true);
		bv.set(5);
		bv2.set(5);
		bv.xor(bv2);
		assertEquals(".xor() : 3", bv2.test(5), false);
		bv.unset(6);
		bv2.set(6);
		bv.xor(bv2);
		assertEquals(".xor() : 4", bv2.test(6), true);
	} 

	@Test
	public void testCopy() {
		bv.set(18);
		bv.set(19);
		bv.set(20);
		bv2 = (BitVector_19) bv.copy();
		assertEquals(".copy(): 1", bv2.test(18), bv.test(18));
		assertEquals(".copy(): 2", bv2.test(19), bv.test(19));
		assertEquals(".copy(): 3", bv2.test(20), bv.test(20));
	}

	@Test
	public void testIterator() {
		Iterator i = bv.iterator();
		bv.set(0);
		bv.set(1);
		assertEquals("iterator hasnext()", i.hasNext(), true);
	}

	@Test
	public void testBuilder() {
		assertEquals("builder()", bv.builder(), b);
	}

	@Test
	public void testToString() {
		assertEquals("tostring()", bv.toString(), "this bitvector has a max value of " + 31);
	}

}
