package cs307.first;
import threeohseven.BitVector;
import threeohseven.Director;

public class Director_46 implements Director {

	public Director_46() {
		
	}
	/**
	 * @Override
	 * Returns a Builder object that will build BitVectors as specified by a Descriptor.
	 * @param Descriptor dd
	 * @return Builder
	 */
	public Builder makeBuilder(Descriptor dd) {
		BitVector.Descriptor bvd = (BitVector.Descriptor) dd;
		if (bvd.optimizeSpeed()) {
			BuilderS_46 builderS = new BuilderS_46();
			builderS.min = bvd.getLowerBound();
			builderS.max = bvd.getUpperBound();
			builderS.checked = bvd.boundCheckRequired();
			return builderS;
		}
		else if (bvd.optimizeSpace()) {
			BuilderB_46 builderB = new BuilderB_46();
			builderB.min = bvd.getLowerBound();
			builderB.max = bvd.getUpperBound();
			builderB.checked = bvd.boundCheckRequired();
			return builderB;
		}
		else {
			return null;
		}
	}

}
