package test.first.u46;

import threeohseven.BitVector;
import threeohseven.Director;
import threeohseven.BitVector.Iterator;
import cs307.first.Director_46;
import junit.framework.TestCase;

public class TestBitVectorS_46 extends TestCase {

	BitVector bv, bv2;
	Director director;
	BitVector.Descriptor descriptor;
	BitVector.Builder builder;

	protected void setUp() throws Exception {
		super.setUp();

		director = new Director_46();
		descriptor = new BitVector.Descriptor(0, 29, false, true, true);
		builder = (BitVector.Builder) director.makeBuilder(descriptor);

		bv = builder.buildBitVector();
		bv2 = builder.buildBitVector();
	}
	
	public void testtoString() {
		bv = builder.buildBitVector();
		bv.negate(0);
		bv.negate(29);
		bv.negate(10);
		assertEquals(bv.toString(), "100000000010000000000000000001");
	}
	
	public void testIterator() {
		Iterator it = bv.iterator();
		bv.set(16);
		it.skipToSet();
		assertEquals(it.position(), 16);
	}
	
	public void testAnd() {
		bv.negate(0);
		bv2.negate(0);
		bv.negate(2);
		bv.negate(4);
		bv.negate(6);
		bv.negate(29);
		bv2.negate(29);
		bv2.negate(5);
		bv.and(bv2);
		assertEquals(bv.test(0), true);
		assertEquals(bv.test(2), false);
		assertEquals(bv.test(3), false);
		assertEquals(bv.test(29), true);
	}
	
	public void testNegate() {
		director = new Director_46();
		descriptor = new BitVector.Descriptor(0, 200, true, false, true);
		builder = (BitVector.Builder) director.makeBuilder(descriptor);
		bv = builder.buildBitVector();
		for (int i=0; i<100; i++) {
			bv.set(i + 50);
		}
		bv.set(20);
		bv.set(180);
		for (int i=0; i<100; i++) {
			assertEquals(bv.test(i+50), true);
		}
		assertEquals(bv.test(20), true);
		assertEquals(bv.test(180), true);
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		
		director = null;
		descriptor = null;
		builder = null;
		bv = null;
		bv2 = null;
	}

}
