/*****
 * Bit Vector
 *****/

package cs307.first;

/**
 * @author -
 *
 */
public class BitVectorSpace_u49 implements BitVector {

	private byte vector[];
	private int size;
	private int low;
	
	/**
	 * @param low_
	 * @param high_
	 * @param maker
	 */
	public BitVectorSpace_u49 (int low_, int high_, BitVector.Builder maker) {
		byte src[] = new byte[((high_ - low_)/8)+1];
		
		builder = (BuilderSpace_u49) maker;
		iterator = new Iterator_u49(this);
		size = high_ - low_;
		low = low_;
		vector = src;
	}

	public boolean test(int index) {
		int byteNum = index / 8;
		byte set = vector[byteNum];
		int bitNum = index % 8;
		int res;
		
		if (!valid(index))
			throw new NoSuchElementError("Invalid bit, does not exist.");
			//throw new cs307.first.ImplementationError("Invalid bit, does not exist.");
		
		switch (bitNum) {
			case 0:	res = set >>> 7;		break;
			case 1:	res = set >>> 6 & 1; 	break;
			case 2:	res = set >>> 5 & 1; 	break;
			case 3:	res = set >>> 4 & 1;	break;
			case 4:	res = set >>> 3 & 1;	break;
			case 5:	res = set >>> 2 & 1;	break;
			case 6:	res = set >>> 1 & 1;	break;
			default:	res = set & 1;
		}
		
		if (res == 1)
			return true;
		else
			return false;
	}
			
	public boolean set(int index) {
		int byteNum = index / 8;
		int bitNum = index % 8;
		boolean old = test(index);
		
		if (!valid(index))
			throw new cs307.first.ImplementationError("Invalid bit, does not exist.");
		
		switch (bitNum) {
			case 0:	vector[byteNum] = (byte) ((int) vector[byteNum] | 0x80);	break;
			case 1:	vector[byteNum] = (byte) ((int) vector[byteNum] | 0x40);	break;
			case 2:	vector[byteNum] = (byte) ((int) vector[byteNum] | 0x20);	break;
			case 3:	vector[byteNum] = (byte) ((int) vector[byteNum] | 0x10);	break;
			case 4:	vector[byteNum] = (byte) ((int) vector[byteNum] | 0x08);	break;
			case 5:	vector[byteNum] = (byte) ((int) vector[byteNum] | 0x04);	break;
			case 6:	vector[byteNum] = (byte) ((int) vector[byteNum] | 0x02);	break;
			default:	vector[byteNum] = (byte) ((int) vector[byteNum] | 0x01);
		}
		
		return old;
	}
	
	public boolean unset(int index) {
		int byteNum = index / 8;
		int bitNum = index % 8;
		boolean old = test(index);
		
		if (!valid(index))
			throw new cs307.first.ImplementationError("Invalid bit, does not exist.");
		
		switch (bitNum) {
			case 0:	vector[byteNum] = (byte) ((int) vector[byteNum] & 0x7F);	break;
			case 1:	vector[byteNum] = (byte) ((int) vector[byteNum] & 0xBF);	break;
			case 2:	vector[byteNum] = (byte) ((int) vector[byteNum] & 0xDF);	break;
			case 3:	vector[byteNum] = (byte) ((int) vector[byteNum] & 0xEF);	break;
			case 4:	vector[byteNum] = (byte) ((int) vector[byteNum] & 0xF7);	break;
			case 5:	vector[byteNum] = (byte) ((int) vector[byteNum] & 0xFB);	break;
			case 6:	vector[byteNum] = (byte) ((int) vector[byteNum] & 0xFD);	break;
			default:	vector[byteNum] = (byte) ((int) vector[byteNum] & 0xFE);
		}
		
		return old;
	}
	
	public boolean negate(int index) {
		if (!valid(index))
			throw new cs307.first.ImplementationError("Invalid index, does not exist.");
		
		if (test(index))
			return unset(index);
		else
			return set(index);
	}
	
	public void and(BitVector bs) {
		int l;
		
		for ( l = 0; l < (size / 8) + 1; l ++ )
			vector[l] = (byte) ((int) vector[l] & (int) ((BitVectorSpace_u49) bs).getByte(l));
	}
	
   public void or(BitVector bs) {
		int l;
		
		for ( l = 0; l < (size / 8) + 1; l ++ )
			vector[l] = (byte) ((int) vector[l] | (int) ((BitVectorSpace_u49) bs).getByte(l));
	}
	
   public void xor(BitVector bs) {
		int l;
		
		for ( l = 0; l < (size / 8) + 1; l ++)
			vector[l] = (byte) ((int) vector[l] ^ (int) ((BitVectorSpace_u49) bs).getByte(l));
		
	}
	
   public BitVector copy() {
		BitVectorSpace_u49 cpy = (BitVectorSpace_u49) builder.buildBitVector();
		int l;
		
		for (l = 0; l < size; l ++) {
			if (test(l))
				cpy.set(l);
			else
				cpy.unset(l);
		}
		
		cpy.iterator = iterator;
		
		return cpy;
	}
   
	public Iterator iterator() {
		return iterator;
	}
	
   public Builder builder() {
		return builder;
	}
	
	public String toString() {
		String output = "";
		int i;
		
		for (i = 0; i < size; i ++) {
			if (test(i))
				output = output + "1";
			else
				output = output + "0";
			
			if (i % 8 == 7)
				output = output + " ";
		}
		
		return output;
	}
	
	/**
	 * @param index
	 * @return
	 */
	private boolean valid (int index) {
		if (!builder.des.boundCheckRequired())
			return true;
		
		if (index >= low && index <= low + size)
			return true;
		else
			return false;
	}
	
	/**
	 * @param index
	 * @return
	 */
	public byte getByte (int index) {
		return vector[index];
	}
	
	public BitVector.Descriptor descriptor;
	public BuilderSpace_u49 builder;
	public Iterator_u49 iterator;

}

