/*****
 * 
 *****/

package cs307.first;


/**
 * @author -
 *
 */
public class BitVectorSpeed_u49 implements BitVector {

	private boolean vector[];
	private int size;
	private int low;
	
	/**
	 * @param low_
	 * @param high_
	 * @param maker
	 */
	public BitVectorSpeed_u49(int low_, int high_, Builder maker) {
		boolean src[] = new boolean[(high_ - low_)];
		
		builder = (BuilderSpeed_u49) maker;
		iterator = new Iterator_u49(this);
		size = high_ - low_;
		low = low_;
		vector = src;
	}

	public boolean test(int index) {
		if (!valid(index))
			throw new NoSuchElementError("Invalid bit, does not exist.");
			//throw new cs307.first.ImplementationError("Invalid bit, does not exist.");
		
		return vector[index];
	}
	
	public boolean set(int index) {
		boolean old = test(index);
		
		if (!valid(index))
			throw new cs307.first.ImplementationError("Invalid bit, does not exist.");
		
		vector[index] = true;
		return old;
	}
	
	public boolean unset(int index) {
		boolean old = test(index);
		
		if (!valid(index))
			throw new cs307.first.ImplementationError("Invalid bit, does not exist.");
		
		vector[index] = false;
		return old;
	}
	
	public boolean negate(int index) {
		boolean old = test(index);
		
		if (!valid(index))
			throw new cs307.first.ImplementationError("Invalid bit, does not exist.");
		
		vector[index] = !vector[index];
		return old;
	}
	
	public void and(BitVector bs) {
		int l;
		
		if (!builder.compatible(((BitVectorSpeed_u49) bs).builder))
			throw new cs307.first.ImplementationError("Invalid types, cannot compute.");
		
		for ( l = 0; l < size; l ++)
			vector[l] = vector[l] & bs.test(l);
	}
	
   public void or(BitVector bs) {
		int l;
		
		if (!builder.compatible(((BitVectorSpeed_u49) bs).builder))
			throw new cs307.first.ImplementationError("Invalid types, cannot compute.");
			
		for ( l = 0; l < size; l ++)
			vector[l] = vector[l] | bs.test(l);
	}
	
   public void xor(BitVector bs) {
		int l;
		
		if (!builder.compatible(((BitVectorSpeed_u49) bs).builder))
			throw new cs307.first.ImplementationError("Invalid types, cannot compute.");
			
		for ( l = 0; l < size; l ++)
			vector[l] = vector[l] ^ bs.test(l);
	}
	
   public BitVector copy() {
		BitVectorSpeed_u49 cpy = (BitVectorSpeed_u49) builder.buildBitVector();
		int l;
		
		for ( l = 0; l < size; l ++ ) {
			if (test(l))
				cpy.set(l);
			else
				cpy.unset(l);
		}
		
		cpy.iterator = iterator;
						
		return cpy;
	}
	
   public Iterator iterator() {
		return iterator;
	}
	
   public Builder builder() {
		return builder;
	}
	
	public String toString() {
		String output = "";
		int i;
		
		for (i = 0; i < size; i ++) {
			if (test(i))
				output = output + "1";
			else
				output = output + "0";
			
			if (size % 8 == 7)
				output = output + " ";
		}
	
		return output;
	}
	
	/**
	 * @param index
	 * @return
	 */
	private boolean valid (int index) {
		if (!builder.des.boundCheckRequired())
			return true;
		
		if (index >= low && index <= low + size)
			return true;
		else
			return false;
	}

   public BuilderSpeed_u49 builder;
   public Iterator_u49 iterator;
   public BitVector.Descriptor descriptor;
   
}

