package test.first.u49;


import org.junit.*;

import cs307.first.*;

public class TestBuilders_u49 {

	Director direct;
	
	@Before
	public void setUp() throws Exception {
		direct = new Director_u49();
	}


	/**
	 * Builds BitVectors with different descriptor conditions, checking for the different patterns
	 * it can be given to see if it builds the correct BitVector as the Director is designed for.
	 * This is that if either it is optimized for speed OR space, if its both or neither, it then
	 * checks sizes based against the value set (currently 127).
	 * @throws Exception
	 */
	@Test
	public void testBuild() throws Exception {
		BitVector.Descriptor smallDescriptSet = new BitVector.Descriptor(0,31,false,true,true);
		BitVector.Descriptor smallDescriptLoose = new BitVector.Descriptor(0,31,false,false,true);
		BitVector.Descriptor bigDescriptSet = new BitVector.Descriptor(0,200,true,false,true);
		BitVector.Descriptor bigDescriptLoose = new BitVector.Descriptor(0,200,false,false,true);
		BitVector.Descriptor smallDescriptCon = new BitVector.Descriptor(0,31,true,true,true);
		BitVector.Descriptor bigDescriptCon = new BitVector.Descriptor(0,200,true,true,true);
		
		int chkCnt = 0;
		BitVector.Builder builder = (BitVector.Builder) direct.makeBuilder(smallDescriptSet);
		
		if (builder instanceof BuilderSpeed_u49)
			chkCnt++;
		
		builder = (BitVector.Builder) direct.makeBuilder(smallDescriptLoose);
		
		if (builder instanceof BuilderSpeed_u49)
			chkCnt++;
		
		builder = (BitVector.Builder) direct.makeBuilder(smallDescriptCon);
		
		if (builder instanceof BuilderSpeed_u49)
			chkCnt++;

		builder = (BitVector.Builder) direct.makeBuilder(bigDescriptSet);
		
		if (builder instanceof BuilderSpace_u49)
			chkCnt++;
		
		builder = (BitVector.Builder) direct.makeBuilder(bigDescriptLoose);
		
		if (builder instanceof BuilderSpace_u49)
			chkCnt++;
	
		builder = (BitVector.Builder) direct.makeBuilder(bigDescriptCon);
		
		if (builder instanceof BuilderSpace_u49)
			chkCnt++;
		
		Assert.assertEquals("Build different cases",chkCnt,6);
	}
	
	/**
	 * Makes different builders and checks the compatibility tester for different types of builder
	 * compatibilities.
	 * @throws Exception
	 */
	@Test
	public void testBuilder() throws Exception {
		BitVector.Descriptor desc = new BitVector.Descriptor(0,31,true,false,true);
		BitVector.Builder build1 = (BitVector.Builder) direct.makeBuilder(desc);
		BitVector.Builder build2 = (BitVector.Builder) direct.makeBuilder(desc);
		
		Assert.assertTrue("Test compatible", build1.compatible(build2));
		
		desc = new BitVector.Descriptor(0,31,false,true,true);
		build2 = (BitVector.Builder) direct.makeBuilder(desc);
		
		Assert.assertFalse("Test incompaptibe", build1.compatible(build2));
	}
	
	@After
	public void tearDown() throws Exception {
	}

}
