package test.first.u49;


import org.junit.*;
import org.junit.Assert;
import cs307.first.*;

public class TestIterate_u49 {
	BitVector bv;
	
	@Before
	public void setUp() throws Exception {
		Director direct = new Director_u49();
		BitVector.Descriptor desc = new BitVector.Descriptor(0, 16, false, true, true);
		BitVector.Builder build = (BitVector.Builder) direct.makeBuilder(desc);
		
		bv = build.buildBitVector();
	}
	
	/**
	 * Modifies the created <code>BitVector</code> bv to test the functionality of its
	 * <code>Iterator</code> in regards to the <code>skipToSet</code>, <code>skitToUnset</code>,
	 * and <code>hasNext</code>
	 * @throws Exception
	 */
	@Test
	public void testIterator() throws Exception {
		bv.set(3);
		BitVector.Iterator i = bv.iterator();
		
		Assert.assertEquals("Test skipToSet", 3, i.skipToSet());
		Assert.assertEquals("Test skipToUnset", 4, i.skipToUnset());
		
		bv.set(14);
		i.skipToSet();
		Assert.assertTrue("Test hasNext true", i.hasNext());
		i.getNext();
		Assert.assertFalse("Test hasNext false", i.hasNext());
	}

	@After
	public void tearDown() throws Exception {
	}

}
