/**
 * 
 */
package test.first.u49;

import cs307.first.*;
import org.junit.*;
import org.junit.Assert;

/**
 * @author -
 *
 */
public class TestVectors_u49 {

	Director direct;
	
	/**
	 * @throws Exception
	 */
	@Before
	public void setUp() throws Exception {
		direct = new Director_u49();
	}

	/**
	 * Tests the basic functionality of two speed efficient or "small" BitVectors by first creating
	 * one called "small1" then runs it through <code>set</code>, <code>unset</code>, and <code>negate</code>.
	 * Then copies the small1 vector as small2 and tests these against a control BitVector in the
	 * <code>xor</code>, <code>and</code>, and <code>or</code> operations
	 * @throws Exception
	 */
	@Test
	public void Small() throws Exception {
		BitVector.Descriptor smallDescript = new BitVector.Descriptor(0,16,false,true,true);
		BitVector.Builder builder = (BitVector.Builder) direct.makeBuilder(smallDescript);
		
		BitVector small1 = (BitVector) builder.build();
		
		small1.set(5);
		Assert.assertTrue("Small set test",small1.test(5));
		small1.unset(5);
		Assert.assertFalse("Small unset test",small1.test(5));
		small1.negate(3);
		Assert.assertTrue("Small negate test",small1.test(3));
		small1.unset(3);
		
		BitVector small2 = (BitVector) small1.copy();
		BitVector smallControl = (BitVector) builder.build();
		BitVector empty = (BitVector) builder.build();
		
		// XOR: "0101000000000000" XOR "1010000000000000" = "11110000000000000"
		smallControl.set(0); smallControl.set(1); smallControl.set(2); smallControl.set(3);
		small1.set(0); small1.set(2); small2.set(1); small2.set(3);
		
		small2.xor(small1);
		
		if (!smallControl.toString().equals(small2.toString()))
			Assert.fail("Small xor test");
		
		small1 = empty.copy();
		small2 = empty.copy();
		
		// AND: "0110000000000000" AND "1010000000000000" = "0010000000000000"
		smallControl.unset(0); smallControl.unset(1); smallControl.set(2); smallControl.unset(3);
		small1.set(1); small1.set(2); small2.set(0); small2.set(2);
		
		small2.and(small1);
		
		if (!smallControl.toString().equals(small2.toString()))
			Assert.fail("Small and test");
		
		small1 = empty.copy();
		small2 = empty.copy();
		
		// OR: "111000000000000" OR "1010000000000000" = "11100000000000000"
		smallControl.set(0); smallControl.set(1); smallControl.set(2); smallControl.unset(3);
		small1.set(0); small1.set(1); small1.set(2); small2.set(0); small2.set(2);
		
		small2.or(small1);
		
		if (!smallControl.toString().equals(small2.toString()))
			Assert.fail("Small or test");
	}
	
	/**
	 * Tests the basic functionality of two space efficient or "big" BitVectors by first creating
	 * one called "big1" then runs it through <code>set</code>, <code>unset</code>, and <code>negate</code>.
	 * Then copies the big1 vector as big2 and tests these against a control BitVector in the
	 * <code>xor</code>, <code>and</code>, and <code>or</code> operations
	 * 
	 * @throws Exception
	 */
	@Test
	public void Big() throws Exception {
		BitVector.Descriptor bigDescript = new BitVector.Descriptor(0,16,true,false,true);
		BitVector.Builder builder = (BitVector.Builder) direct.makeBuilder(bigDescript);
		
		BitVector big1 = (BitVector) builder.build();
		
		big1.set(5);
		Assert.assertTrue("big set test",big1.test(5));
		big1.unset(5);
		Assert.assertFalse("big unset test",big1.test(5));
		big1.negate(3);
		Assert.assertTrue("big negate test",big1.test(3));
		big1.unset(3);
		
		BitVector big2 = (BitVector) big1.copy();
		BitVector bigControl = (BitVector) builder.build();
		BitVector empty = (BitVector) builder.build();
		
		// XOR: "0101000000000000" XOR "1010000000000000" = "11110000000000000"
		bigControl.set(0); bigControl.set(1); bigControl.set(2); bigControl.set(3);
		big1.set(0); big1.set(2); big2.set(1); big2.set(3);
		
		big2.xor(big1);
		
		if (!bigControl.toString().equals(big2.toString()))
			Assert.fail("big xor test");
		
		big1 = empty.copy();
		big2 = empty.copy();
		
		// AND: "0110000000000000" AND "1010000000000000" = "0010000000000000"
		bigControl.unset(0); bigControl.unset(1); bigControl.set(2); bigControl.unset(3);
		big1.set(1); big1.set(2); big2.set(0); big2.set(2);
		
		big2.and(big1);
		
		if (!bigControl.toString().equals(big2.toString()))
			Assert.fail("big and test");
		
		big1 = empty.copy();
		big2 = empty.copy();
		
		// OR: "111000000000000" OR "1010000000000000" = "11100000000000000"
		bigControl.set(0); bigControl.set(1); bigControl.set(2); bigControl.unset(3);
		big1.set(0); big1.set(1); big1.set(2); big2.set(0); big2.set(2);
		
		big2.or(big1);
		
		if (!bigControl.toString().equals(big2.toString()))
			Assert.fail("big or test");
	}
	
	/**
	 * @throws Exception
	 */
	@After
	public void tearDown() throws Exception {
	}

}
