package cs307.first;

import cs307.threeohseven.Director;
//import first.*;
//import java.util.Vector;

/**
 * The Director interface for 307-PA1
 **/

/**
 * A Director is responsible for creating builders. This is an
 * implementation of the Builder pattern from the GoF which exposes the
 * builder objects. This version of the pattern is a general interface for
 * directors which has not been specialized to BitVectors. The advantage of
 * remaining non-specific is that we can use this interface in different
 * context, the drawback is that additional typecasts will be
 * required. Since builders are rarely constructed in a tight loop the
 * performance overhead of the casts is deemed acceptable.
 *
 * @author -
 * @version 1.0.0
 **/

public class Director_51 implements Director 
{

    /**
     * Create a builder from a descriptor.
     * @param dd non-null descriptor 
     * @throws ImplementationError if there
     * is no suitable implementation for this descriptor
     **/
    //public Builder makeBuilder(Descriptor d)
    //{
	//Builder_51 b = new Builder_51((Descriptor_51)d);
	//return (Builder)b;
    //}
	
	public Director_51()
	{}
    
    public Builder_51 makeBuilder(Descriptor_51 d)
    {
    	//System.out.println("in side make builder, passing descriptor with "+d.getUpperBound());
    	Builder_51 b = new Builder_51(d);
		return (Builder_51)b;
    }
    public Builder makeBuilder(cs307.threeohseven.BitVector.Descriptor d)
    {
    	Builder_51 b = new Builder_51(d);
		return (cs307.threeohseven.BitVector.Builder)b;
    }
    public Builder makeBuilder(cs307.threeohseven.Director.Descriptor d)
    {
    	Builder_51 b = new Builder_51(d);
		return (cs307.threeohseven.BitVector.Builder)b;
    }
    
}// End of Director
