/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cs307.first;

/**
 * The Builder class implements the BitVector.Builder interface and is used to
 * build a BitVector
 * @author -
 */
public class BuilderSmall_68 implements BitVector.Builder {

    private int _low = 0, _high = -1;
    
    /**
     * Constructos a builder given a bitVector range.
     * @param low Lower bound on the BitVector
     * @param high Higher bound on the BitVector
     */
    public BuilderSmall_68(int low, int high) {
        _low = low;
        _high = high;
    }
    
    /**
     * Build a BitVector
     * @return The BitVector built from this builder
     */
    public BitVector build(){
        return buildBitVector();
    }
    
    /**
     * Return a new empty BitVector.
     **/
    public BitVector buildBitVector(){
        return new BitVectorSmall_68(_low, _high);
    }

    /**
     * Returns a new BitVector identical to <code>val</code>. This is a
     * deep copy in the sense that there is no logical sharing of
     * mutable state between the two objects. 
     * @throws ImplementationError if the argument's builder
     *  is not compatible  with the reciever.
     **/
    public BitVector buildBitVector(BitVector val){
        if(! this.compatible(val.builder())){
            throw new ImplementationError("Incompatable assignment");
        }
        return new BitVectorSmall_68(val);
    }

    /**
     * Return true if the builders have the same internal state.
     **/
    public boolean equals(Object other){
        try{
            ((BuilderSmall_68)other).toString();
            return true;
        }catch(java.lang.ClassCastException c){
            return false;
        }catch(Error e){
            return false;
        }
    }

    /**
     * Returns true if the two builders are compatible. This method is
     * required to return true if the builders are
     * <code>.equals</code>. For builders of different classes the
     * method returns true when the implementation is able to convert between
     * representations. <p>
     **/
    public boolean compatible(BitVector.Builder other){
        if(equals(other)){
            return true;
        }
        return false;
    }
}
