/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cs307.first;

/**
 * The Iterator class implements the BitVector.Iterator interface and provides
 * an iterator for the BitVector interface
 * @author -
 */
public class Iterator_68 implements BitVector.Iterator {

    private BitVector _bv;
    private int _cursor,  _high;

    /**
     * Constructor, takes the bitVector in question with the low and high bounds
     * @param bv The BitVector for which this iterator is supposed to itterate
     * @param low The lower bound of the bitVector
     * @param high The upper bound of the BitVector
     */
    public Iterator_68(BitVector bv, int low, int high) {
        _bv = bv;
        _high = high;
        _cursor = low;
    }

    /**
     * Are there more values in the active range?
     * @return false if the end of the range has been reached.
     **/
    public boolean hasNext() {
        if (_cursor <= _high) {
            return true;
        }
        return false;
    }

    /**
     * Returns the value for the current cursor, and advances the
     * cursor by one. When the cursor overflows the active range
     * (i.e. <code>hasNext()</code> is false) arbitrary values may be
     * returned. Implementations are not required to throw an exception.
     * @return the value of the next index in range.
     * @throws NoSuchElementError if hasNext() == false and vector is strict.
     **/
    public boolean getNext() {
        if (!hasNext()) {
            // NO MORE
            return false;
        }
        _cursor++;
        return _bv.test(_cursor - 1);
    }

    /**
     * The value of the cursor. This value may be larger than the
     * vector's upper bound. In which case <code>hasNext()</code> will
     * return false.
     * @return current position.
     **/
    public int position() {
        return _cursor;
    }

    /**
     * Skips to the next set bit such that <code>getNext()</code> will
     * return true, if none is found the cursor is moved to the end of
     * the vector and <code>hasNext()</code> will return false from
     * thereon.
     * @return position of the first set bit, if there is none an
     * invalid value will be returned (ie a value larger than the upper
     * bound of the array).
     **/
    public int skipToSet() {
        for(; _cursor <=_high; ++_cursor){
            if(_bv.test(_cursor)){
                break;
            }
        }
        return _cursor;
    }

    /**
     * Skips to the next unset bit such that <code>getNext()</code>
     * will return false, if none is found the cursor is moved to the
     * end of the vector and <code>hasNext()</code> will return false
     * from thereon.
     * @return position of the first unset bit, if there is none an
     * invalid value will be returned (ie a value larger than the upper
     * bound of the array).
     **/
    public int skipToUnset(){
        for(; _cursor <=_high; ++_cursor){
            if(!_bv.test(_cursor)){
                break;
            }
        }
        return _cursor;
    }
}
