package test.first.u68;


import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import test.first.u68.OptimizationTesting.Ops;

import cs307.first.BitVector;
import cs307.first.Director_68;
import cs307.first.Director.Builder;

public class FindCriticalPoint {

	enum Ops {OR, AND, XOR, TEST, SET, UNSET, NEGATE};
	
	private final int UL = 100000, LL = 0;
	private long sinms = 1000;
	private int _uLimit, _lLimit;	
	private int _start1 = 50, _end1 = 130, _step1 = 10;
	private int _start2 = 10000, _end2 = 20000, _step2 = 2000;
	private int _case1Size = 2000, _case2Size = 50;
	private Ops[] set1 = {Ops.AND, Ops.OR, Ops.TEST};
	private Ops[] set2 = {Ops.SET, Ops.TEST};
	private BitVector[] testVectors;
	private Director_68 testDirector;
	
	@Before
	public void setUp() throws Exception {
		testDirector = new Director_68();
		//testDirector._lowerLimit = LL;
		//testDirector._upperLimit = UL;
	}

	@After
	public void tearDown() throws Exception {
		testDirector = null;
	}
	
	
	@Test
	public void findCriticalPoint_Case1(){
		System.out.println("Case 1 approche\n---------------");
		long time1 , time2;
		_lLimit = 0;
		for(int i=_start1; i<_end1; i+=_step1){
			_uLimit = i;
			makeVectors(_lLimit, _uLimit, true, false, _case1Size);
			time1 = testSet(set1);
			makeVectors(_lLimit, _uLimit, false, true, _case1Size);
			time2 = testSet(set1);
			System.out.print(i+": ");
			if(time1 < time2){
				System.out.print("Space Code Wins ("+((time2-time1)/sinms)+") ");
			}else if(time2 < time1){
				System.out.print("Speed Code Wins ("+((time1-time2)/sinms)+") ");
			}else{
				System.out.print("No Difference");
			}
			System.out.println("["+time1+","+time2+"]");
		}
		System.out.println("Complete");
	}
	
	@Test
	public void findCriticalPoint_Case2(){
		fail();
		System.out.println("Case 2 approche\n---------------");
		long time1 , time2;
		_lLimit = 0;
		for(int i=_start2; i<_end2; i+=_step2){
			_uLimit = i;
			makeVectors(_lLimit, _uLimit, true, false, _case2Size);
			time1 = testSet(set2);
			makeVectors(_lLimit, _uLimit, false, true, _case2Size);
			time2 = testSet(set2);
			System.out.print(i+": ");
			if(time1 < time2){
				System.out.print("Space Code Wins ("+((time2-time1)/sinms)+") ");
			}else if(time2 < time1){
				System.out.print("Speed Code Wins ("+((time1-time2)/sinms)+") ");
			}else{
				System.out.print("No Difference");
			}
			System.out.println("["+time1+","+time2+"]");
		}
		System.out.println("Complete");
	}
	
	
	private long testSet(Ops[] funcs){
		long start = System.currentTimeMillis();
		for(int i=0; i<funcs.length; ++i){			
			switch(funcs[i]){
			case AND:
				doAND();
				break;
			case OR:
				doOR();
				break;
			case TEST:
				doTEST();
				break;
			case SET:
				doSET();
				break;
			default:
				break;
			}			
		}
		return System.currentTimeMillis() - start;
	}
	
	private void doOR(){
		for(int i=0; i<testVectors.length; ++i){
			for(int j=0; j<testVectors.length; ++j){
				testVectors[i].or(testVectors[j]);
			}
		}
	}		
	
	private void doAND(){
		for(int i=0; i<testVectors.length; ++i){
			for(int j=0; j<testVectors.length; ++j){
				testVectors[i].and(testVectors[j]);
			}
		}
	}
	
	private void doTEST(){
		for(int i=0; i<testVectors.length; ++i){
			for(int j=_lLimit; j<=_uLimit; ++j){
				testVectors[i].test(j);
			}
		}
	}
	
	private void doSET(){
		for(int i=0; i<testVectors.length; ++i){
			for(int j=_lLimit; j<=_uLimit; ++j){
				testVectors[i].set(j);
			}
		}
	}
	
	private void doAlternate(){
		for(int i=0; i<testVectors.length; ++i){
			for(int j=_lLimit; j<=_uLimit; ++j){
				if(j%2 == 0){
					testVectors[i].set(j);
				}else{
					testVectors[i].unset(j);
				}
			}
		}
	}
	
	private void makeVectors(int ul, int ll, boolean space, boolean speed, int num){
		BitVector.Descriptor temp1 = new BitVector.Descriptor(ul, ll, space, speed, true);
		Builder temp2 = testDirector.makeBuilder(temp1);
		testVectors = new BitVector[num];
		for(int i=0; i<testVectors.length; ++i){
			testVectors[i] = (BitVector)temp2.build();
		}
	}	

}
