package test.first.u68;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import cs307.first.BitVector;
import cs307.first.Director;
import cs307.first.Director_68;
import cs307.first.ImplementationError;
import cs307.first.Director.Builder;

public class TestBigBuilder {
	
	private int _limit = 60; // Power of 2 should be problematic
	 	// NOTE: do not reduce below 40 otherwise test will enter an ifninite loop

	private Director testDirector = new Director_68();
	private BitVector.Descriptor testDescriptor = new BitVector.Descriptor(0, _limit, false, true, true);
	private Builder testBuilder;

	@Before
	public void setUp() throws Exception {
		testBuilder = testDirector.makeBuilder(testDescriptor);
	}

	@After
	public void tearDown() throws Exception {
		testBuilder = null;
	}

	@Test
	public void testBuilderSpeed_kdosenba() {
		assertNotNull(testBuilder);
	}

	@Test
	public void testBuild() {
		BitVector testVector = (BitVector)testBuilder.build();
		assertNotNull(testVector);
	}

	@Test
	public void testBuildBitVector() {
		BitVector testVector1 = (BitVector)((BitVector.Builder)testBuilder).buildBitVector();
		assertNotNull(testVector1);
	}

	@Test
	public void testBuildBitVectorBitVector() {
		BitVector testVector1 = (BitVector)((BitVector.Builder)testBuilder).buildBitVector();
		try{
			BitVector testVector2 = (BitVector)((BitVector.Builder)testBuilder).buildBitVector(testVector1);
			BitVector.Iterator iter1 = testVector1.iterator();
			BitVector.Iterator iter2 = testVector2.iterator();
			while(iter1.hasNext() && iter2.hasNext()){
				assertEquals("Not Equal Bit", iter1.getNext(), iter2.getNext());
			}
		}catch (ImplementationError error){
			fail("Implementation Error");
		}	
	}

	@Test
	public void testEqualsObject() {
		Builder testBuilder2 = testDirector.makeBuilder(testDescriptor);
		assertEquals("Different Builder", testBuilder, testBuilder2);
	}

	@Test
	public void testCompatible() {
		Builder testBuilder2 = testDirector.makeBuilder(testDescriptor);
		assertEquals("Different Builder", testBuilder, testBuilder2);
	}

}
