package cs307.first;

import threeohseven.BitVector;


/**
 * Builder that generates a generic BitVector implementation
 */
public class BuilderGeneral_7 implements BitVector.Builder {
	protected int low, high;
	protected boolean checked;
	
	public BuilderGeneral_7 (BitVector.Descriptor bd) {
		low = bd.getLowerBound ();
		high = bd.getUpperBound ();
		checked = bd.boundCheckRequired ();
	}
	
	public BitVector buildBitVector() {
		return new BitVectorGeneral_7 ((BitVector.Builder) this, low, high, checked);
	}
	
	public BitVector buildBitVector(BitVector val) {
		return val.copy ();
	}
	
	public Object build () {
		return (Object) buildBitVector ();
	}
	
	public boolean equals(Object other) {
		if (!(other instanceof BuilderGeneral_7))
			return false;

		BuilderGeneral_7 bg = (BuilderGeneral_7) other;
		if (bg.low != low || bg.high != high || bg.checked != checked)
			return false;

		return true;
	}
	
	public boolean compatible(BitVector.Builder other) {
		if (!(other instanceof BuilderGeneral_7))
			return false;
			
		BuilderGeneral_7 bg = (BuilderGeneral_7) other;
		return bg.low == low && bg.high == high;
	}
}

