package cs307.first;

import threeohseven.BitVector;

/**
 * Builder that produces BitVectors that are optimized for space
 */
public class BuilderSpace_7 extends BuilderGeneral_7 {
	public BuilderSpace_7 (BitVector.Descriptor bd) {
		super (bd);
	}
	
	public BitVector buildBitVector() {
		return new BitVectorSpace_7 ((BitVector.Builder) this, low, high, checked);
	}
	
	public BitVector buildBitVector(BitVector val) {
		return val.copy ();
	}
	
	public Object build () {
		return (Object) buildBitVector ();
	}
	
	public boolean equals(Object other) {
		if (!(other instanceof BuilderSpace_7))
			return false;

		BuilderSpace_7 bg = (BuilderSpace_7) other;
		if (bg.low != low || bg.high != high || bg.checked != checked)
			return false;

		return true;
	}
}

