package cs307.first;

import threeohseven.Director;
import threeohseven.BitVector;
import threeohseven.ImplementationError;

/**
 * Director that produces Builders from BitVector Descriptors
 */
public class Director_7 implements Director {
	public Director_7 () {
		
	}
	
	public Builder makeBuilder(Director.Descriptor dd) {
		if (!(dd instanceof BitVector.Descriptor))
			throw new ImplementationError ("Not given a proper descriptor");

		BitVector.Descriptor bd = (BitVector.Descriptor) dd;
		if (bd.optimizeSpace ()) {
			return new BuilderSpace_7 (bd);
		} else {
			return new BuilderGeneral_7 (bd);
		}
	}
}

