package cs307.first.u7;

import threeohseven.BitVector;
import threeohseven.BitVector.Builder;
import cs307.first.*;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

public class Director_7Test extends TestCase {
	protected Director_7 director;
	
	public static void main (String[] args) {
		TestRunner.run (suite ());
	}
	
	public Director_7Test (String name) {
		super (name);
	}
	
	public static Test suite () {
		TestSuite suite = new TestSuite ();
		
		suite.addTest (new Director_7Test ("testSmall"));
		suite.addTest (new Director_7Test ("testLarge"));
		suite.addTest (new Director_7Test ("testGeneral"));
		
		return suite;
	}
	
	protected void setUp() throws Exception {
		super.setUp();
		
		this.director = new Director_7 ();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		
		this.director = null;
	}
	
	public void testSmall () {
		BitVector.Descriptor dd = new BitVector.Descriptor (0, 127, true, false, true);
		BitVector.Builder b = (Builder) this.director.makeBuilder(dd);
		
		assertEquals ("Small descriptor doesn't return space compact representation", b.getClass(), BuilderSpace_7.class);
		
		BitVector bv = b.buildBitVector();
		
		bv.set(0);
		bv.set(127);
		bv.set(64);
		bv.set(63);
		
		assertEquals ("Set failed at index: 0", true, bv.test (0));
		assertEquals ("Set failed at index: 63", true, bv.test (63));
		assertEquals ("Set failed at index: 64", true, bv.test (64));
		assertEquals ("Set failed at index: 127", true, bv.test (127));

		bv.unset(0);
		bv.unset(127);
		bv.unset(64);
		bv.unset(63);
		
		assertEquals ("Unset failed at index: 0", false, bv.test (0));
		assertEquals ("Unset failed at index: 63", false, bv.test (63));
		assertEquals ("Unset failed at index: 64", false, bv.test (64));
		assertEquals ("Unset failed at index: 127", false, bv.test (127));

	}
	
	public void testLarge () {
		BitVector.Descriptor dd = new BitVector.Descriptor (0, 2047, true, false, true);
		BitVector.Builder b = (Builder) this.director.makeBuilder(dd);
		
		assertEquals ("Large descriptor doesn't return space compact representation", b.getClass(), BuilderSpace_7.class);
		
		BitVector bv = b.buildBitVector();
		
		bv.set(0);
		bv.set(1023);
		bv.set(1024);
		bv.set(2047);
		
		assertEquals ("Test failed at index: 0", true, bv.test (0));
		assertEquals ("Test failed at index: 1023", true, bv.test (1023));
		assertEquals ("Test failed at index: 1024", true, bv.test (1024));
		assertEquals ("Test failed at index: 2047", true, bv.test (2047));
	}
	
	public void testGeneral () {
		BitVector.Descriptor dd = new BitVector.Descriptor (0, 127, false, false, true);
		BitVector.Builder b = (Builder) this.director.makeBuilder(dd);
		
		assertEquals ("General desriptor doesn't return general representation", b.getClass(), BuilderGeneral_7.class);
		
		BitVector bv = b.buildBitVector();
		
		bv.set(0);
		bv.set(63);
		bv.set(64);
		bv.set(127);
		
		assertEquals ("Test failed at index: 0", true, bv.test (0));
		assertEquals ("Test failed at index: 63", true, bv.test (63));
		assertEquals ("Test failed at index: 64", true, bv.test (64));
		assertEquals ("Test failed at index: 127", true, bv.test (127));

		bv.unset(0);
		bv.unset(127);
		bv.unset(64);
		bv.unset(63);
		
		assertEquals ("Unset failed at index: 0", false, bv.test (0));
		assertEquals ("Unset failed at index: 63", false, bv.test (63));
		assertEquals ("Unset failed at index: 64", false, bv.test (64));
		assertEquals ("Unset failed at index: 127", false, bv.test (127));
	}
}
