package cs307.first;

import threeohseven.*;

public class BitVector_u72 implements threeohseven.BitVector, Cloneable
{

  public long frontEnd, backEnd;
  public boolean []list;
  private boolean fast, space, useDouble, strict;
  private int high, low;
  private Builder_u72 curBuild;
  private Iterator_u72 cursor;

  public boolean test(int index)
  {
    if( index > high )
      throw new ImplementationError("index too high");
    else if( index < low )
      throw new ImplementationError("index too low");
    if( useDouble)
    {
      long val = 1;
      long test;
      if( index < 64 )
      {
        val = val << index;
        test = frontEnd;
      }
      else
      {
        val = val << index % 64;
        test = backEnd;
      }
      test = test & val;
      return (test != 0 ? true : false);
    }
    else
    {
      return list[index];
    }
  }

  public boolean set(int index) throws ImplementationError
  {
    if( index > high )
      throw new ImplementationError("index too high");
    else if( index < low )
      throw new ImplementationError("index too low");
    if( useDouble )
    {
      long val = 1;
      if( index < 64 )
      {
        val = val << index;
        frontEnd = frontEnd | val;
      }
      else
      {
        val = val << index % 64;
        backEnd = backEnd | val;
      }
    }
    else
    {
      list[index] = true;
    }
    return true;
  }
  
  public boolean unset(int index)
  {
    if( index > high )
      throw new ImplementationError("index too high");
    else if( index < low )
      throw new ImplementationError("index too low");
    if( useDouble )
    {
      long val = 1;
      if( index < 64 )
      {
        val = val << index;
        frontEnd = frontEnd & ~val;
      }
      else
      {
        val = val << index % 64;
        backEnd = backEnd & ~val;
      }
    }
    else
    {
      list[index] = false;
    }
    return true;
  }
 
  public boolean negate(int index)
  {
    if( index > high )
      throw new ImplementationError("index too high");
    else if( index < low )
      throw new ImplementationError("index too low");
    if( useDouble )
    {
      if( test(index) )
      {
        this.unset(index);
  	return true;
      }
      else
      {
 	this.set(index);
	return false;
      }
    }
    else
    {
      if( list[index] )
        list[index] = false;
      else
	list[index] = true;
      return !list[index];
    }
  }

  public void and(BitVector bs)
  {
    if( useDouble )
    {
      if( strict && !bs.builder().compatible(this.builder()) )
      {
      	throw new ImplementationError("Inavlid and operation");
      }
      this.frontEnd = this.frontEnd & ((BitVector_u72)bs).frontEnd;
      this.backEnd = this.backEnd & ((BitVector_u72)bs).backEnd;
    }
    else
    {
      int i, max;
      if( strict && !bs.builder().compatible(this.builder()) )
      	throw new ImplementationError("Inavlid and operation");
      if( !strict && !bs.builder().compatible(this.builder()) )
      {
	i = ( this.low < ((BitVector_u72)bs).low ? this.low : ((BitVector_u72)bs).low );
	max = ( this.high < ((BitVector_u72)bs).high ? this.high : ((BitVector_u72)bs).high );
      }
      else
      {
        i = this.low;
        max = this.high;
      }
        for( ; i < max; i++ )
        {
          if( this.list[i] && ((BitVector_u72)bs).list[i] )
            this.list[i] = true;
  	  else
	    this.list[i] = false;
        }
    }
  }

  public void or(BitVector bs)
  {
    if( useDouble )
    {
      if( strict && !bs.builder().compatible(this.builder()) )
      {
      	throw new ImplementationError("Inavlid and operation");
      }
      this.frontEnd = this.frontEnd | ((BitVector_u72)bs).frontEnd;
      this.backEnd = this.backEnd | ((BitVector_u72)bs).backEnd;
    }
    else
    {
      int i, max;
      if( strict && !bs.builder().compatible(this.builder()) )
      	throw new ImplementationError("Inavlid and operation");
      if( !strict && !bs.builder().compatible(this.builder()) )
      {
	i = ( this.low < ((BitVector_u72)bs).low ? this.low : ((BitVector_u72)bs).low );
	max = ( this.high < ((BitVector_u72)bs).high ? this.high : ((BitVector_u72)bs).high );
      }
      else
      {
        i = this.low;
        max = this.high;
      }
        for( ; i < max; i++ )
        {
          if( this.list[i] || ((BitVector_u72)bs).list[i] )
            this.list[i] = true;
  	  else
	    this.list[i] = false;
        }
    }
  }

  public void xor(BitVector bs)
  {
    if( useDouble )
    {
      if( strict && !bs.builder().compatible(this.builder()) )
      {
      	throw new ImplementationError("Inavlid and operation");
      }
      this.frontEnd = this.frontEnd ^ ((BitVector_u72)bs).frontEnd;
      this.backEnd = this.backEnd ^ ((BitVector_u72)bs).backEnd;
    }
    else
    {
      int i, max;
      if( strict && !bs.builder().compatible(this.builder()) )
      	throw new ImplementationError("Inavlid and operation");
      if( !strict && !bs.builder().compatible(this.builder()) )
      {
	i = ( this.low < ((BitVector_u72)bs).low ? this.low : ((BitVector_u72)bs).low );
	max = ( this.high < ((BitVector_u72)bs).high ? this.high : ((BitVector_u72)bs).high );
      }
      else
      {
        i = this.low;
        max = this.high;
      }
        for( ; i < max; i++ )
        {
          if( this.list[i] != ((BitVector_u72)bs).list[i] )
            this.list[i] = true;
  	  else
	    this.list[i] = false;
        }
    }
  }

  public BitVector copy()
  {
    
    try
    {
      BitVector_u72 bs = (BitVector_u72)this.clone();
      bs.cursor = (Iterator_u72)this.cursor.clone();
      bs.curBuild = (Builder_u72)this.curBuild.clone();
      if( useDouble )
        return bs;
      else
      {
        bs.list = (boolean[])this.list.clone();
	return bs;
      }
    }
    catch( CloneNotSupportedException e )
    {
      throw new ImplementationError("Bad Copy");
    }
  }

  public Iterator iterator()
  {
    return cursor;
  }

  public Builder builder()
  {
    return (Builder)curBuild;
  }

  public String toString()
  {
    String holder = "";
    for( int i = low; i <= high; i++ )
    {
      holder += ( i + "\t\t" + this.test(i) + "\n");
    }
    return holder;
  }

  public  void setUseDouble(boolean val)
  {
    useDouble = val;
  }

  public boolean getUseDouble()
  {
    return useDouble;
  }

  public void setFast(boolean val)
  {
    fast = val;
  }
  
  public boolean getFast()
  {
    return fast;
  }

  public void setSpace(boolean val)
  {
    space = val;
  }

  public boolean getSpace()
  {
    return space;
  }

  public void setStrict(boolean val)
  {
    strict = val;
  }

  public boolean getStrict()
  {
    return strict;
  }

  public void setHigh(int val)
  {
    high = val;
  }

  public int getHigh()
  {
    return high;
  }

  public void setLow(int val)
  {
    low = val;
  }

  public int getLow()
  {
    return low;
  }
 
  public void setCurBuild(Builder val)
  {
    try
    {
      Builder_u72 temp = (Builder_u72)val;
      curBuild = (Builder_u72)temp.clone();
    }
    catch(CloneNotSupportedException e )
    {
      throw new ImplementationError("bad copy");
    }
  }

  public void createCursor()
  {
    cursor = new Iterator_u72(low, high, strict, this);
  }
 
  public Object clone() throws CloneNotSupportedException
  {
    return super.clone();
  }
}

