package cs307.first;

import threeohseven.*;
import threeohseven.BitVector.*;

public class Builder_u72 implements threeohseven.BitVector.Builder, 
Cloneable
{
  int high, low;
  boolean checked, optSpeed, optSpace;

  public BitVector buildBitVector()
  {
    return (BitVector)build();
  }

  public BitVector buildBitVector(BitVector val)
  {
    BitVector_u72 bs = (BitVector_u72)val;
    if( !bs.builder().compatible(this) )
      throw new ImplementationError("builders are not compatible");
    return val.copy();
  }

  public boolean equals(Object other)
  {
    Builder_u72 bs = (Builder_u72)other;
    Builder_u72 bc = (Builder_u72)this;
    if( bc.low == bs.low && 
        bc.high == bs.high && 
        bc.checked == bs.checked &&
        bc.optSpeed == bs.optSpeed &&
       	bc.optSpace == bs.optSpace )
      return true;
    else
      return false;
  }

  public boolean compatible(Builder other)
  {
    Builder_u72 bs = (Builder_u72)other;
    Builder_u72 bc = (Builder_u72)this;
    if( bc.low == bs.low && 
        bc.high == bs.high )
      return true;
    else
      return false;
  }

  public Object build()
  {
    BitVector_u72 vector = new BitVector_u72();
    if( high <= 127 && optSpeed )
      vector.setUseDouble(true);
    else if( high <= 127 && !optSpace )
      vector.setUseDouble(true);
    else if( optSpace )
      vector.setUseDouble(false);
    vector.setFast(optSpeed);
    vector.setSpace(optSpace);
    vector.setHigh(high);
    vector.setLow(low);
    vector.setStrict(checked);
    vector.setCurBuild(this);
    vector.createCursor();
    if( !vector.getUseDouble() )
    {
      vector.list = new boolean[high+1];
      for( int i = 0; i < high+1; i++ )
        vector.list[i] = false;
    }
    else
    {
      vector.frontEnd = 0;
      vector.backEnd = 0;
    }
    return (Object)vector;
  }

  public Builder makeBuilder()
  {
    Builder_u72 builder = new Builder_u72();
    return (BitVector.Builder)builder;
  }
  
  public void setHigh(int val)
  {
    high = val;
  }

  public void setLow(int val)
  {
    low = val;
  }

  public void setChecked(boolean val)
  {
    checked = val;
  }

  public void setOptSpeed(boolean val)
  {
    optSpeed = val;
  }

  public void setOptSpace(boolean val)
  {
    optSpace = val;
  }
  
  public int getHigh()
  {
    return high;
  }

  public int getLow()
  {
    return low;
  }

  public boolean getChecked()
  {
    return checked;
  }

  public boolean getOptSpeed()
  {
    return optSpeed;
  }

  public boolean getOptSpace()
  {
    return optSpace;
  }

  public Object clone() throws CloneNotSupportedException
  {
    return super.clone();
  }

}
