package cs307.first;

import threeohseven.*;
import threeohseven.BitVector.*;

public class Iterator_u72 implements threeohseven.BitVector.Iterator, 
Cloneable
{

  private int low, high, curPos;
  private boolean strict;
  private BitVector_u72 vector;

  public Iterator_u72(int lowVal, int highVal, boolean strictVal, BitVector_u72 vectorVal)
  {
    low = lowVal;
    high = highVal;
    curPos = low;
    strict = strictVal;
    vector = vectorVal;
  }

  public boolean hasNext()
  {
    if( curPos != high )
      return true;
    return false;
  }
  
  public boolean getNext()
  {
    if( !hasNext() && vector.getStrict() )
      throw new NoSuchElementError("No such element");
    return vector.test(curPos++);
  }
 
  public int position()
  {
    return curPos;
  }

  public int skipToSet()
  {
    curPos++;
    for( ; curPos < high; curPos++ )
    {
      if( vector.test(curPos) )
        return curPos;
    }
    return curPos + high;
  }
  
  public int skipToUnset()
  {
    curPos++;
    for( ; curPos < high; curPos++ )
    {
      if( !vector.test(curPos) )
        return curPos;
    }
    return curPos + high;
  }

  public Object clone() throws CloneNotSupportedException
  {
    return super.clone();
  }
}
