package cs307.first;

import java.util.Vector;

import threeohseven.BitVector;
import threeohseven.ImplementationError;

/**
 * 
 * @author -
 *
 * The BitVector class. Maps integers to boolean values.
 */
public class BitVector_77 implements BitVector {

	public Vector<String> theBits;
    public int low_;
    public int high_;
    public boolean strict;
    public boolean optSpeed_;
    public boolean optSpace_;
    
/**
 * The constructor keeps track of the values and initializes the Vector to all zeroes.
 * @param low integer
 * @param high integer
 * @param speed boolean
 * @param space boolean
 * @param check boolean
 */
    public BitVector_77(int low, int high, boolean speed, boolean space, boolean check){
	this.theBits = new Vector<String>(high+1);
	for(int i = 0; i <= high; i++){
		theBits.add("0");
	}
	
	this.low_ = low;
	this.high_ = high;
	this.strict = check;
	this.optSpeed_ = speed;
	this.optSpace_ = space;
	

    }

	
    /**
     * Logical <code>and</code> of the two vectors. Receiver is updated in
     * place.  The operation is only valid if <code>index</code> is in the
     * active range of the <code>BitVector</code>.
     * @param bs the other <code>BitVector</code>.
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
	public void and(BitVector bs) {
		BitVector_77 cs = (BitVector_77)bs;

		if(this.low_ == cs.low_ && this.high_ == cs.high_){
		    for(int i = this.low_; i < this.high_;i++){
			
		    	if(this.theBits.elementAt(i) == "1" && cs.theBits.elementAt(i) == "1"){
		    		this.theBits.setElementAt("1",i);
		    	}
		    	else{
		    		this.theBits.setElementAt("0",i);
		    	}

		    }


		}
		else{
		    if(this.strict = true || cs.strict == true){//if strict throw index out of bounds error
			throw new ImplementationError("Index out of bounds");
		    }
		}



	}

    /**
     * Returns the builder that created this <code>BitVector</code>.
     **/
	public Builder builder() {
		Descriptor small = new Descriptor(this.low_,this.high_,this.optSpace_,this.optSpeed_,this.strict);
		Builder hello = new Builder_77(small);

		return hello;
	}

    /**
     * Returns a logically disjoint copy of the object.  The operation is
     * only valid if the two <code>BitVector</code> objects are compatible.
     * @param bs the other <code>BitVector</code>.
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code>
     **/
	public BitVector copy() {
		BitVector_77 hello = new BitVector_77(this.low_,this.high_,
			      this.optSpeed_,this.optSpace_,
			      this.strict);	
		for(int i = 0; i <= high_; i++){
			if(this.test(i)){
				hello.set(i);
			}		
		}
		return hello;

	}

    /**
     * Returns an iterator over this <code>BitVector</code>.
     **/
	public Iterator iterator() {
		Iterator hello = new Iterator_77(this.low_,this.high_,theBits,strict);

		return hello;
		

	}

    /**
     * Reverses the value at a valid index.
     * @param index a value in the active range
     * @return old value at <code>index</code>
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
	public boolean negate(int index) {
		boolean result;

		if(low_ <= index && index <= high_){
		    if(theBits.elementAt(index) == "1"){
			result = true;
			theBits.setElementAt("0",index);//previous result was true so set to false
		    }
		    else{
			result = false;
			theBits.setElementAt("1",index);//previous result was false so set to true
		    }
		    


		}
		else{//check if the bitvector is strict or not
		    if(strict = true){//if strict throw index out of bounds error
			throw new ImplementationError("Index out of bounds");
		    }
		    return false;//otherwise return false
		}


		return result;	

	}

	  /**
     * Logical <code>or</code> of the two vectors. Receiver is updated in
     * place.  The operation is only valid if the two
     * <code>BitVector</code> objects are compatible.
     * @param bs the other <code>BitVector</code>.
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
	public void or(BitVector bs) {
		BitVector_77 cs = (BitVector_77)bs;

		if(this.low_ == cs.low_ && this.high_ == cs.high_){
		    for(int i = this.low_; i < this.high_;i++){
			
			if(this.theBits.elementAt(i) == "1" || cs.theBits.elementAt(i) == "1"){
			    this.theBits.setElementAt("1",i);
			}
			else{
			    this.theBits.setElementAt("0",i);
			}

		    }


		}
		else{
		    if(this.strict = true || cs.strict == true){//if strict throw index out of bounds error
			throw new ImplementationError("Index out of bounds");
		    }
		}

	}

    public String toString(){
    	String hello = this.low_ + " to " + this.high_ + " opt for space:" + this.optSpace_ + 
    	    " opt for speed: " + this.optSpeed_ + " Strict:" + strict;

    	return hello;
        }
	
    /**
     * If the index is within valid ranges it sets the element at the index to true.
     * @param index a value in the active range
     * @return old value at <code>index</code>
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
	public boolean set(int index) {
		boolean result;
		if(low_ <= index && index <= high_){
		    if(theBits.elementAt(index) == "1"){
			result = true;
		    }
		    else{
			result = false;
		    }
		    theBits.setElementAt("1",index);


		}
		else{//check if the bitvector is strict or not
		    if(strict = true){//if strict throw index out of bounds error
			throw new ImplementationError("Index out of bounds");
		    }
		    return false;//otherwise return false
		}


		return result;

	}

    /**
     * It first checks that the index is between low and high.  It then checks the value at index
     * If it is "1" it returns true, other wise it returns false.
     * If the index is out of bounds and strict is set to true, then it throws an error.
     * @param index a value in the active range
     * @return value at <code>index</code> 
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
	public boolean test(int index) throws ImplementationError{
		if(low_ <= index && index <= high_){	  
		    if(theBits.elementAt(index) == "1"){
			return true;
		    }
		    else{
			return false;
		    }

		   
		}
		else{//check if the bitvector is strict or not
		    if(strict = true){//if strict throw index out of bounds error
			throw new ImplementationError("Index out of bounds");
		    }
		    return false;//otherwise return false
		}	

	}

    /**
     * Sets the bit at a valid index to false.
     * @param index a value in the active range
     * @return old value at <code>index</code>
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
	public boolean unset(int index) {
		boolean result;

		if(low_ <= index && index <= high_){
		    if(theBits.elementAt(index) == "1"){
			result = true;
		    }
		    else{
			result = false;
		    }
		    theBits.setElementAt("0",index);


		}
		else{//check if the bitvector is strict or not
		    if(strict = true){//if strict throw index out of bounds error
			throw new ImplementationError("Index out of bounds");
		    }
		    return false;//otherwise return false
		}


		return result;	

	}

    /**
     * Logical <code>xor</code> of the two vectors. Receiver is updated in
     * place.  The operation is only valid if the two
     * <code>BitVector</code> objects are compatible.
     * @param bs the other <code>BitVector</code>.
     * @throws ImplementationError if the operation is invalid and the
     * <code>BitVector</code> is strict.
     **/
	public void xor(BitVector bs) {
		BitVector_77 cs = (BitVector_77)bs;

		if(this.low_ == cs.low_ && this.high_ == cs.high_){
		    for(int i = this.low_; i < this.high_;i++){
			
			if(this.theBits.elementAt(i) == "1" && cs.theBits.elementAt(i) == "1"){
			    this.theBits.setElementAt("0",i);
			}
			else if(this.theBits.elementAt(i) == "1" && cs.theBits.elementAt(i) == "0"){
			    this.theBits.setElementAt("1",i);
			}
			else if(this.theBits.elementAt(i) == "0" && cs.theBits.elementAt(i) == "1"){
			    this.theBits.setElementAt("1",i);
			}
			else{
			    this.theBits.setElementAt("0",i);
			}

		    }


		}
		else{
		    if(this.strict = true || cs.strict == true){//if strict throw index out of bounds error
			throw new ImplementationError("BitVectors not the same");
		    }
		}

	}

}
