package cs307.first;

import threeohseven.BitVector;
import threeohseven.Director.Descriptor;

/**
 * 
 * @author -
 * This is the builder class.  The builder can create a new Bit Vector from scratch
 * or it can make a copy of an existing BitVector
 */
public class Builder_77  implements BitVector.Builder  {

		public boolean optSpace_;
	    public boolean optSpeed_;
	    public int low_;
	    public int high_;
	    public boolean checked_;
	    
	    /**
	     * This builder function takes a descriptor that contains the necessary information, and copies it into it's internal 
	     * variables.  
	     * @param dd
	     */
	 public Builder_77(Descriptor dd){
		 	BitVector.Descriptor cc = (BitVector.Descriptor)dd;
		 	
			this.optSpace_ = cc.optimizeSpace();
			this.optSpeed_ = cc.optimizeSpeed();
			this.low_ = cc.getLowerBound();
			this.high_ = cc.getUpperBound();
			this.checked_ = cc.boundCheckRequired();
			
			
	 }
	 /**
	  * This builder takes no arguments and returns an object.  You must cast the return value if you want to 
	  * use it as a BitVector.
	  */
	 public Object build(){
	        BitVector_77 myBit = new BitVector_77(this.low_,this.high_,this.optSpeed_,this.optSpace_,this.checked_);


		return myBit;
	    }

	 /**
	  * This returns an actual BitVector object so it requires no cast. 
	  */
	public BitVector buildBitVector(){
	
		BitVector_77 hello = new BitVector_77(this.low_,this.high_,this.optSpeed_,
			      										this.optSpace_, this.checked_);

		return hello;
		
		
	}

	/**
	 * Returns a new BitVector identical to <code>val</code>. This is a
	 * deep copy in the sense that there is no logical sharing of
	 * mutable state between the two objects. 
	 * @throws ImplementationError if the argument's builder
	 *  is not compatible  with the receiver.
	 *  @param BitVector 
	 **/
		public BitVector buildBitVector(BitVector val){
		BitVector_77 temp = (BitVector_77) val;
		BitVector_77 hello = new BitVector_77(temp.low_,temp.high_,temp.optSpeed_,
						       temp.optSpace_,temp.strict);

		hello.theBits = temp.theBits;

		return hello;

		
		
	}
	/**
	 * Return true if the builders have the same internal state.
	 * It compares all the class variables and makes sure they are all equal.
	 * @param Object Must be cast to Builder_77 type before use
	 **/
	public boolean equals(Object other){
		Builder_77 temp = (Builder_77) other;



		return this.optSpace_ == temp.optSpace_ &&
		    this.optSpeed_ == temp.optSpeed_ &&
		    this.low_ == temp.low_ &&
		    this.high_ == temp.high_ &&
		    this.checked_ == temp.checked_;

	}
	/**
	 * Returns true if the two builders are compatible. This method is
	 * required to return true if the builders are
	 * <code>.equals</code>. For builders of different classes the
	 * method returns true when the implementation is able to convert between
	 * representations. <p>
	 * @param BitVector.Builder 
	 **/
	public boolean compatible(BitVector.Builder other){
		if(equals(other)) return true;
		return false;
	}

}


