package cs307.first;

import java.util.Vector;

import threeohseven.BitVector;

import threeohseven.BitVector.NoSuchElementError;;


/**
 * @author -
 *The iterator class allows a user to iterate over all the values in a bitvector, or it can jump to the
 *first set or unset bit.
 */
public class Iterator_77 implements BitVector.Iterator {

	int low;
    int high;
    int index;
    Vector<String> bits;
    boolean strict_;

    /**
     * Constructor
     * @param l integer must be less than h
     * @param h integer must be higher than l
     * @param theBits Vector<String> 
     * @param strict boolean if true, errors will throw exceptions
     */
    public Iterator_77(int l, int h,Vector<String> theBits, Boolean strict){
    	this.low = l;
    	this.high = h;
    	this.index = l;
    	this.bits = theBits;
    	this.strict_ = strict;
    }

    /**
     * checks if index is curretnly less than or equal to high
     */
    public boolean hasNext(){

    	return (index <= high);
    }
/**
 * makes sure there are more values and returns the next one
 */
    public boolean getNext() throws NoSuchElementError{
    	boolean result;
    	if(hasNext() == false )
    	{
    		if( this.strict_ == true){
    			
    		
    		throw new NoSuchElementError("index out of range");
    		}
    		else
    		{
    			return false;
    		}
	    }
    	
    	if(bits.elementAt(index) == "1"){
    		result = true;
    	}
    	else{
    		result = false;
    	}

    	index++;



    	return result;

    }

    /**
     * returns the index
     */
    public int position(){
	
    	return index;
    }

    /**
     * skips to the first true bit.  If the bit at the current index is true it stays in place
     */
    public int skipToSet(){
    	if(bits.elementAt(index)=="1") return index;

		while(hasNext()){
			if(getNext() == true){
				index--;
				return position();
		    }
		}
		return high+1;
    }

    /**
     * skips to the first false bit.  If the bit at the current index is false it stays in place.
     */
    public int skipToUnset(){
    	if(bits.elementAt(index)=="0") return index;
		while(hasNext()){
		    if(getNext() == false){
		    	index--;
		    	return position();
		    }
		}
	
		return high+1; //it did not find a valid position so it returns an index outside the valid bounds
    }





}
