/**
 * The Builder_u83 class for 307-PA1
 * @author -
 **/

package cs307.first;
import threeohseven.*;

public class Builder_u83 implements BitVector.Builder{

    private int low;
    private int high;
    private boolean checked;
    private boolean optSpace;
    private boolean optSpeed;

    public Builder_u83 (int inc_low, int inc_high, boolean inc_checked,
			     boolean int_optSpace, boolean inc_optSpeed){
	low = inc_low;
	high = inc_high;
	checked = inc_checked;
	optSpace = int_optSpace;
	optSpeed = inc_optSpeed;
    }


  /**
   * Return a new empty BitVector.
   **/
    public BitVector buildBitVector(){
	return new BitVector_u83(low, high, checked, this);
    }

  /**
   * Returns a new BitVector identical to <code>val</code>. This is a
   * deep copy in the sense that there is no logical sharing of
   * mutable state between the two objects. 
   * @throws ImplementationError if the argument's builder
   *  is not compatible  with the reciever.
   **/
    public BitVector buildBitVector(BitVector val){
	BitVector bv = (BitVector_u83) val;
	bv = bv.copy();
	return bv;
    }


  /**
   * Return true if the builders have the same internal state.
   **/
    public boolean equals(Object other){
	if (!(other instanceof Builder_u83)) return false;
	Builder_u83 otherb = (Builder_u83) other; 
	if (low == otherb.getLow() && high == otherb.getHigh() &&
	    checked == otherb.getChecked() && optSpace == otherb.getOptSize() &&
	    optSpeed == otherb.getOptSpeed())
	    return true;
	else
	    return false;

    }

    public Object build(){
	return buildBitVector();
    }
	


  /**
   * Returns true if the two builders are compatible. This method is
   * required to return true if the builders are
   * <code>.equals</code>. For builders of different classes the
   * method returns true when the implementation is able to convert between
   * representations. <p>
   **/
    public boolean compatible(BitVector.Builder other){
	return this.equals(other);
    }

    public int getLow(){
	return low;
    }
    public int getHigh(){
	return high;
    }
    public boolean getChecked(){
	return checked;
    }
    public boolean getOptSize(){
	return optSpace;
    }
    public boolean getOptSpeed(){
	return optSpeed;
    }
  
} // end of Builder




