package cs307.first;

import cs307.first.BitVector;
import cs307.first.BitVector_93;
import cs307.first.Director;
import cs307.first.BitVector.Descriptor;
import cs307.first.BitVector.Builder;

public class Builder_93 implements Builder {

	private BitVector.Descriptor dis;
	private int low;
	private int high;
	private boolean checked;
	private boolean speed;
	private boolean space;
	 //  ===================== Constructors ========================= 
	
	public Builder_93()
	{
		low = 0;
		high = 1;
		checked = false;
		speed = false;
		space = false;
		dis = new Descriptor(low, high); 
	}
	
	public Builder_93(BitVector.Descriptor dd)
	{
		dis = dd;
		low = dd.getLowerBound();
		high = dd.getUpperBound();
		checked = dd.boundCheckRequired();
		speed = dd.optimizeSpeed();
		space = dd.optimizeSpace();
	}
	
	public Builder_93(Director.Descriptor dd)
	{
		dis = (Descriptor) dd;
		low = ((Descriptor) dd).getLowerBound();
		high = ((Descriptor) dd).getUpperBound();
		checked = ((Descriptor) dd).boundCheckRequired();
		speed = ((Descriptor) dd).optimizeSpeed();
		space = ((Descriptor) dd).optimizeSpace();
	}

	 // ========================= General Methods ==============================
	
	/**
	 * Name: buildBitVector
	 * 
	 * Function: creates a new BitVector_93 based upon
	 * 				the descriptor of the builder
	 * 
	 * Returns: a newly created BitVector (all values will be false)
	 */
	public BitVector buildBitVector() {
		BitVector_93 bv = new BitVector_93((Descriptor) dis);
		bv.setBuilder(this);
		return bv;
	}

	/**
	 * Name: buildBitVector
	 * 
	 * Function: Creates a deep copy of val
	 * 
	 * Params: BitVector val- The BitVector that is to be copied
	 * 
	 * Returns: A deep, 1 to 1 copy of val
	 */
	public BitVector buildBitVector(BitVector val) {
		BitVector_93 nu = new BitVector_93((Descriptor) dis);
		int i = nu.getLow();
		while( i < nu.getHigh())
		{
			nu.getData().set(i, ((BitVector_93) val).getData().get(i));
		}
		nu.setBuilder(this);
		return nu;
	}

	/**
	 * Name: compatible
	 * 
	 * Function: Compares two builders to see if they are compatible
	 * 
	 * Params: Builder other - the other builder that is to be compared
	 * 
	 * Returns: Boolean weather they are compatible (true) or not (false)
	 */
	public boolean compatible(Builder other) {
		if(dis.getDescription().equals(((Descriptor) other.getDis()).getDescription()))
			return true;
		return false;
	}
	/**
	 * Name: build()
	 * 
	 * Function: This is not complete.  I don't use it but have to have it
	 * 				to fulfill my implementation requirement
	 * 
	 * Returns: null
	 */
	@Override
	public Object build() {
		return null;
	}
	
	
	
	 // =========================== Get Methods ======================
	 
	
	/**
	 * Returns the Descriptor of the Builder
	 */
	public Descriptor getDis()
	{
		return (Descriptor) dis;
	}
	/**
	 * Returns the Upper Bound of the Builder
	 */
	public int getHigh()
	{
		return high;
	}
	/**
	 * Returns the lower bound of the Builder
	 */
	public int getLow()
	{
		return low;
	}
	/**
	 * Returns weather the Builder will make BitVectors optimized for Speed
	 */
	public boolean optSpeed()
	{
		if(speed == true) return true;
		return false;
	}
	/**
	 * Returns weather the Builder will make BitVectors that are strict or lax
	 */
	public boolean checked()
	{
		return checked;
	}
}
