package cs307.first;

import java.util.Scanner;

import cs307.first.BitVector;
import cs307.first.Builder_93;

public class Director_93 implements Director {

	int low;
	int high;
	boolean optSpeed;
	boolean optSpace;
	boolean checked;
	public Descriptor dis;
	
	public Director_93()
	{
		Scanner input = new Scanner(System.in);
		low = 0;
		high = 0;
		String opt = "";
		optSpeed = false;
		optSpace = false;
		checked = false;
		System.out.print("Welcome to Bryce Harcourt's BitVector Program");
		System.out.println("To start off, let's make a Descriptor.");
		
		int i = 0;
		while (i ==0){
			System.out.println("What is the lower bound?");
			low = input.nextInt();		//get low
			System.out.println("Next we need to know the upper bound: ");
			high = input.nextInt();		//get high
			if(high <= low)
				System.out.println("Upper bound cannot be higher or equal to lower bound.");
			else 
				i++;
		}
		System.out.println("Is this Builder to specialize in speed? (Type y or n)");
		opt = input.next();			//find optimization
		
		while(opt.charAt(0) != 'n' && opt.charAt(0) != 'y')
		{
			System.out.println("I'm sorry, you need to answer with 'y' or 'n'");
			System.out.println("Is this Builder to specialize in speed? (Type y or n)");
			opt = input.next();
		}
		if(opt.charAt(0) == 'y')
			optSpeed = true;		//if opt is true for speed, set optspeed true
		else optSpace = true;		//if not optspeed, then optspace is true
		
		System.out.println("Great.  Now do we want this to be strict or lax when it comes" +
				" to throwing exceptions?  (input 's' for strict and 'l' for lax)");
		opt = input.next();			//find optimization
		while(opt.charAt(0) != 'l' && opt.charAt(0) != 's')
		{
			System.out.println("I'm sorry, you need to answer with 's' or 'l'");
			System.out.println("Is this Builder to be strict or lax? (Type s or l)");
			opt = input.next();
		}	
		if (opt.charAt(0) == 's')
			checked = true;
		dis = new Descriptor(low, high, optSpace, optSpeed, checked);
		System.out.println("\nOK, now we are ready to make the builder.");
	}
	
	/**
	 * What this should do is create the appropriate Builder constructor based
	 * on the Descriptor.
	 */
	public Builder makeBuilder(Descriptor dd) {
		BitVector.Descriptor dis = new BitVector.Descriptor(dd.getLowerBound(), dd.getUpperBound(), dd.optimizeSpace(), dd.optimizeSpeed(), dd.boundCheckRequired());
		Builder nu = new Builder_93(dis);
		return nu;
	}
	
	public int getLow(){
		return low;
	}
	
	public int getHigh(){
		return high;
	}
	
	public boolean Space(){
		return optSpace;
	}
	
	public boolean checked(){
		return checked;
	}
	public class Descriptor
	{
		private final boolean optSpace_;
		private final boolean optSpeed_;
		private final int low_;
		private final int high_;
		private final boolean checked_;
		/**
		 * Make a descriptor for bit vectors from <code>low</code> to
		 * <code>high</code>.
		 * @param low lower bound on active range
		 * @param high higher bound on active range
		 **/
		public Descriptor(int low, int high) {
		    optSpace_ = false;
		    optSpeed_ = false;
		    low_ = low;
		    high_ = high;
		    checked_ = true;
		}

		/**
		 * Make a descriptor for bit vectors from <code>low</code> to
		 * <code>high</code>.
		 * @param low lower bound on active range
		 * @param high higher bound on active range
		 * @param optSpace optimize for space
		 * @param optSpeed optimize for speed
		 * @param checked  full bound checks required
		 **/
		public Descriptor(int low, 
				  int high,
				  boolean optSpace,
				  boolean optSpeed,
				  boolean checked) {
		    optSpace_ = optSpace;
		    optSpeed_ = optSpeed;
		    low_ = low;
		    high_ = high;
		    checked_ = checked;
		}
		
		/**
		 * Should storage space be minimized?
		 **/
		public boolean optimizeSpace() {
		    return optSpace_;
		}
		/**
		 * Should speed be maximized?
		 **/
		public boolean optimizeSpeed() {
		    return optSpeed_;
		}
		/**
		 * Lower bound on active range.
		 **/
		public int getLowerBound() {
		    return low_;
		}
		/**
		 * Upper bound on active range.
		 **/
		public int getUpperBound() {
		    return high_;
		}

		/**
		 * Returns true if bounds checks are required for all accesses. If
		 * this is set to false an implementation may choose not check some
		 * operations. Typically this allows removal of some redundant
		 * checks at the risk of overflowing. If the method returns true,
		 * the corresponding vectors are strict, otherwise they called
		 * relaxed.
		 **/
		public boolean boundCheckRequired() {
		        return checked_;
		}
		public String getDescription()
		{
			return "BitVector [" +low_+","+high_+"], opt space ="+optSpace_
			+" opt speed ="+optSpeed_;
		}
	}

	@Override
	public Builder makeBuilder(cs307.first.Director.Descriptor dd) {
		BitVector.Descriptor dis = new BitVector.Descriptor(((Descriptor) dd).getLowerBound(), ((Descriptor) dd).getUpperBound(), ((Descriptor) dd).optimizeSpace(), ((Descriptor) dd).optimizeSpeed(), ((Descriptor) dd).boundCheckRequired());
		Builder nu = new Builder_93(dis);
		return nu;
	}
}
