package test.first.u93;

import org.junit.After;
import org.junit.Before;

import cs307.first.u93.BitVector;
import test.first.u93.BitVectorTester_93;
import cs307.first.u93.BitVector_93;
import cs307.first.u93.Builder_93;


public class BitVectorTester_93 {

	BitVector_93 bv;
	Builder_93 build;
	
	public BitVectorTester_93(){
		bv = new BitVector_93();
		build = new Builder_93();
		bv.setBuilder(build);
	}
	
	public BitVectorTester_93(int a, int b){
		BitVector_93.Descriptor dis = new BitVector_93.Descriptor(a, b);
		bv = new BitVector_93(dis);
		build = new Builder_93();
		bv.setBuilder(build);
	}
	
	public BitVectorTester_93(BitVector_93 a){
		bv = a;
		build = new Builder_93();
		bv.setBuilder(build);
	}
	
	public BitVectorTester_93(BitVector_93 a, Builder_93 b){
		bv = a;
		build = b;
	}
	
	@Before
	public void setUp() throws Exception {
		bv = new BitVector_93();
		build = null;
	}

	@After
	public void tearDown() throws Exception {
		bv = null;
		build = null;
	}

	public boolean test1(){
		if(bv.getLow() < bv.getHigh())
			return true;
		return false;
	}
	
	public boolean test2(){
		if (bv.getDis() == null)
			return true;
		return false;
	}
	
	public String data(){
		return bv.getData().toString();
	}
	
	public void testSet(){
		int i = bv.getLow();
		while( i < bv.getHigh()){
			bv.set(i);
			i = i+2;
		}
	}
	
	public void testUnset(){
		int i = bv.getLow();
		i++;
		while( i < bv.getHigh()){
			bv.unset(i);
			i = i+2;
		}
	}
	
	public void testNegate(){
		int i = bv.getLow();
		while(i < bv.getHigh()){
			bv.negate(i);
			i++;
		}
	}
	
	public BitVector getBV(){
		return bv;
	}
	
	public void testOr(BitVectorTester_93 a){
		int i = bv.getLow();
		while(i < bv.getHigh()){
			bv.negate(i);
			i = i + 3;
		}
		System.out.println("First new data:     " + data());
		bv.or(a.getBV());
	}
	
	public void testXor(BitVectorTester_93 a){
		this.testNegate();
		bv.xor(a.getBV());
	}
	
	public void testAnd(BitVectorTester_93 a){
		bv.and(a.getBV());
	}
	
	public boolean compare(BitVectorTester_93 a){
		int i = bv.getLow();
		boolean ans = true;
		while(i<bv.getHigh()){
			if (ans == false)
				return false;
			if(bv.test(i) == a.getBV().test(i))
				ans = true;
			else 
				ans = false;
			i++;
		}
		return ans;
	}
	
	public static void main(String[] args){
		
		System.out.println("========== Testing Constructors ==========");
		testDefault();		//test BitVector_93()
		testDefDes();		//test BitVector_93(Descriptor())
		
		System.out.println("========== Testing Logic =================");
		LogicDefDes();
		System.out.println("\nEnd of Testing.  Shutting down");
		/**
		BitVector.Descriptor dis = new BitVector.Descriptor(0,10);
		System.out.println(dis.getDescription());
		*/
	}
	
	public static void testDefault(){
		BitVectorTester_93 blank = new BitVectorTester_93();
		System.out.println("Testing default Constructor");
		System.out.println("Is high greater than low (t):     " + blank.test1());
		System.out.println("Data = : " + blank.data());
		blank.testSet();
		System.out.println("Testing Set. Data now equals:     " + blank.data());
		blank.testUnset();
		System.out.println("Testing Unset(). Data now equals: " + blank.data());
		
		blank = null;
	}
	
	public static void testDefDes(){
		BitVectorTester_93 ohSeven = new BitVectorTester_93(0, 7);
		System.out.println("Testing 0 to 7");
		System.out.println("Is high greater than low (t): " + ohSeven.test1());
		System.out.println("Is Dis undefined (f): " + ohSeven.test2());
		System.out.println("ohSeven Data = " + ohSeven.data());
		ohSeven.testSet();
		System.out.println("Set() every other entry.  Data =  " + ohSeven.data());
		ohSeven.testNegate();
		System.out.println("Negate().  Data =                 " + ohSeven.data());
		ohSeven.testUnset();
		System.out.println("Unset() every other entry. Data = " + ohSeven.data());
		
		ohSeven = null;
	}
	
	public static void LogicDefDes(){
		BitVectorTester_93 first = new BitVectorTester_93(0,10);
		BitVectorTester_93 second;
		System.out.println("Logic testing Vector of size ten");
		first.testSet();
		System.out.println("First Data:         " + first.data());
		second = new BitVectorTester_93(0,10);
		//second.testNegate();
		//second.testUnset();
		System.out.println("Second.Data (static)" + second.data());
		first.testOr(second);
		System.out.println("First.or():         " + first.data());
		second.testUnset();
		first.testAnd(second);
		System.out.println("First.and()         " + first.data());
		first.testXor(second);
		System.out.println("First.xor()         " + first.data());
		
		first = null;
		second = null;
	}
	
	public void LogicTest(){
		BitVectorTester_93 second;
		System.out.println("Logic testing Vector of size ten");
		this.testSet();
		System.out.println("First Data:         " + this.data());
		second = new BitVectorTester_93(this.bv);
		second.testUnset();
		System.out.println("Second.Data (static)" + second.data());
		this.testOr(second);
		System.out.println("First.or():         " + this.data());
		this.testAnd(second);
		System.out.println("First.and()         " + this.data());
		this.testXor(second);
		System.out.println("First.xor()         " + this.data());

		second = null;
	}
}
