package test.first.u93;

import org.junit.After;
import org.junit.Before;

import test.first.u93.BitVectorTester_93;
import cs307.first.u93.BitVector_93;
import test.first.u93.BuilderTester_93;
import cs307.first.u93.Builder_93;
import cs307.first.u93.BitVector.Descriptor;


public class BuilderTester_93 {

	BitVector_93 bv;
	Builder_93 build;
	
	public BuilderTester_93(){
		build = new Builder_93();
		bv = null;
	}
	
	public BuilderTester_93(int a, int b){
		Descriptor dis = new Descriptor(a,b);
		build = new Builder_93(dis);
		bv = null;
	}
	
	public static void main(String[] args){
		BuilderTester_93 defalt = new BuilderTester_93();	//first check default constructor
		System.out.println("================ Testing Builder ===================");
		defalt.testParams();
		defalt.testBuildBV();
		defalt = null;
		BuilderTester_93 first = new BuilderTester_93(0,10);
		System.out.println("================ Testing Constructor ===============");
		System.out.println("Low = 0, High = 10");
		first.testParams();
		first.testBuildBV();
		first.testBitVector();
		
		System.out.println("================ Testing BitVector ================");
		BitVectorTester_93 bvt = new BitVectorTester_93(first.bv, first.build);
		System.out.println("Low = 0, High = 10");
		bvt.LogicTest();
	}
	
	private void testParams(){
		System.out.println("Builder Params: (low, high) = (" + build.getLow() + ", "+ build.getHigh() +
		")  optSpeed = " + build.optSpeed() + "  checked = " + build.checked());
		System.out.println("Descriptor = " + build.getDis().toString());
	}
	
	private void testBuildBV(){
		System.out.println("\n================== Testing BitVector Building ================");
		bv = (BitVector_93) build.buildBitVector();
		System.out.print("BitVector is not null = ");
		if(bv == null)
			System.out.print("false\n*************No BitVector made************\n");
		else
			System.out.print("true\n");
	}
	
	private void testBitVector(){
		bv = (BitVector_93) build.buildBitVector();
		if(build.getLow() == bv.getLow())
			System.out.println("Builder lower bound = BitVector lower bound");
		else
			System.out.println("WARNING: Builder lower bound != BitVector lower bound");
		if(build.getHigh() == bv.getHigh())
			System.out.println("Builder upper bound = BitVector upper bound");
		else
			System.out.println("WARNING: Builder upper bound != BitVector upper bound");
		if(build.optSpeed() == true)
			System.out.println("BitVector is built for speed");
		else
			System.out.println("BitVector is built for space");
		if(build.checked())
			System.out.println("This will be strict");
		else
			System.out.println("This will be lax");
	}
	
	@Before
	public void setUp() throws Exception {
		bv = null;
	}

	@After
	public void tearDown() throws Exception {
		bv = null;
	}
}
